unit APropos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ColorButton, Commun, AppEvnts;

type
  TFicheAPropos = class(TForm)
    LabelTitre: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    ScrollBox: TScrollBox;
    Label_Syntaxe3: TLabel;
    Label_Utilisation3: TLabel;
    Label_Exemple2: TLabel;
    Label_Syntaxe2: TLabel;
    Label_Utilisation2: TLabel;
    Panel7: TPanel;
    Edit_Exemple1: TEdit;
    Label_Exemple1: TLabel;
    Label_Syntaxe1: TLabel;
    Label_Utilisation1: TLabel;
    Edit_Exemple2: TMemo;
    Panel6: TPanel;
    Fermer: TColorButton;
    Panel8: TPanel;
    Label_Mail: TLabel;
    Label2: TLabel;
    Label_Site: TLabel;
    Label_Utilisation4: TLabel;
    Label_Syntaxe4: TLabel;
    Label_Exemple3: TLabel;
    Panel9: TPanel;
    Edit_Exemple3: TEdit;
    Label_Exemple4: TLabel;
    Panel10: TPanel;
    Edit_Exemple4: TEdit;
    Label_Utilisation5: TLabel;
    Label_Syntaxe5: TLabel;
    ApplicationEvents: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Label_MailClick(Sender: TObject);
    procedure Label_SiteClick(Sender: TObject);
    procedure ApplicationEventsMessage(var Msg: tagMSG;
      var Handled: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FicheAPropos: TFicheAPropos;

implementation

uses Principale, ShellAPI, Fonctions;

{$R *.dfm}

procedure TFicheAPropos.FormCreate(Sender: TObject);
var i: integer;
begin
     Caption:=NOMAPPLI+' '+GetVersion+' - A Propos';
     LabelTitre.Caption:=NOMAPPLI;
     Label_Mail.Hint:=ADRESSE_EMAIL;
     Label_Site.Hint:=Label_Site.Hint+' '+URL_SITE;
     Label_Syntaxe1.Caption:=Format(Label_Syntaxe1.Caption, [ExtractFileName(ParamStr(0))]);
     Label_Syntaxe2.Caption:=Format(Label_Syntaxe2.Caption, [ExtractFileName(ParamStr(0))]);
     Label_Syntaxe3.Caption:=Format(Label_Syntaxe3.Caption, [ExtractFileName(ParamStr(0))]);
     Label_Syntaxe4.Caption:=Format(Label_Syntaxe4.Caption, [ExtractFileName(ParamStr(0))]);
     Label_Syntaxe5.Caption:=Format(Label_Syntaxe5.Caption, [ExtractFileName(ParamStr(0))]);
     Edit_Exemple2.Text:=StringReplace(Format(Edit_Exemple2.Text, [ExtractFileName(ParamStr(0))]), #13, '', [rfReplaceAll]);
     Edit_Exemple3.Text:=StringReplace(Format(Edit_Exemple3.Text, [ExtractFileName(ParamStr(0))]), #13, '', [rfReplaceAll]);
     Edit_Exemple4.Text:=StringReplace(Format(Edit_Exemple4.Text, [ExtractFileName(ParamStr(0))]), #13, '', [rfReplaceAll]);
     DoubleBuffered:=true;
     for i:=0 to ComponentCount-1 do
     begin
          if (Components[i] is TPanel) then
          begin
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).ParentBackground := TRUE;
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).DoubleBuffered:=true;
          end
          else
          if Components[i] is TColorButton then with TColorButton(Components[i]) do begin DoubleBuffered:=true; HoverColor:=Color; BackColor:=Color; end
          else
          if Components[i] is TWinControl then TWinControl(Components[i]).DoubleBuffered:=true;
     end;
end;

procedure TFicheAPropos.FormShow(Sender: TObject);
var Chaine: string;
begin
     ScrollBox.VertScrollBar.Position:=0;
     if Configuration.Fichier='' then Chaine:='C:\Fichier test.usf' else Chaine:=Configuration.Fichier;
     Edit_Exemple1.Text:=ExtractFileName(ParamStr(0))+' "'+Chaine+'"';
end;

procedure TFicheAPropos.Label_MailClick(Sender: TObject);
begin
     Screen.Cursor:=crAppStart;
     ShellExecute(Handle, 'open', PChar('mailto:'+ADRESSE_EMAIL), nil, nil, SW_SHOWNORMAL);
     Screen.Cursor:=crDefault;
end;

procedure TFicheAPropos.Label_SiteClick(Sender: TObject);
begin
     Screen.Cursor:=crAppStart;
     ShellExecute(Handle, 'open', PChar(URL_SITE), nil, nil, SW_NORMAL);
     Screen.Cursor:=crDefault;
end;

procedure TFicheAPropos.ApplicationEventsMessage(var Msg: tagMSG; var Handled: Boolean);
var Control: TWincontrol;
begin
     if Msg.Message=WM_MOUSEWHEEL then
     begin
          Control:=FindControl(WindowFromPoint(Mouse.CursorPos));
          if Assigned(Control) then
          begin
               while (Control<>nil) and not (Control is TScrollBox) do Control:=Control.Parent;
               if Control is TScrollBox then
               begin
                    with (Control as TScrollBox).VertScrollBar do
                    begin
                         if Msg.wParam<0 then Position := Position + Increment
                                         else Position := Position - Increment;
                         Handled:=true;
                    end;
               end;
          end else Handled:=true;
    end;
end;

procedure TFicheAPropos.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin if Key=VK_ESCAPE then Fermer.Click; end;

end.
