unit Attente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GIFImage, ExtCtrls;

type
  TFicheAttente = class(TForm)
    Sablier: TImage;
    Horloge: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HorlogeTimer(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FicheAttente: TFicheAttente;
  ProcHandle: cardinal=0;
implementation

uses Principale, Commun;

{$R *.dfm}

procedure TFicheAttente.FormShow(Sender: TObject);
begin
     Left:=FicheUpdateSoft.Left+FicheUpdateSoft.Width-Width-22;
     Top:=FicheUpdateSoft.Top+80;
     Horloge.Tag:=0;
     Horloge.Enabled:=true;
end;

procedure TFicheAttente.FormCreate(Sender: TObject);
var ResourceStream: TResourceStream;
    GIFImage: TGIFImage;
begin
     Color:=FicheUpdateSoft.Color;
     ClientHeight:=32;
     ClientWidth:=32;
     GIFImage := TGIFImage.Create;
     try
        try
           ResourceStream := TResourceStream.Create(hInstance, 'SABLIER', RT_RCDATA);
           try
              GIFImage.LoadFromStream(ResourceStream);
           finally
              ResourceStream.Free
           end;
           Sablier.Picture.Graphic := GIFImage;
        finally
           GIFImage.Free
        end;
     except
     end;
end;

procedure TFicheAttente.HorlogeTimer(Sender: TObject);
begin
     Horloge.Enabled:=false;
     if Horloge.Tag=0 then
     begin
          ProcHandle:=LanceAppli('"'+ParamStr(0)+'" "'+Configuration.Fichier+'"', ExtractFilePath(ParamStr(0)));
          if ProcHandle<>0 then
          begin
               Horloge.Tag:=1;
               Horloge.Enabled:=true;
          end;
     end
     else
     begin
          if WaitForSingleObject(ProcHandle, 0)=WAIT_OBJECT_0 then
          begin
               ProcHandle:=0;
               Horloge.Tag:=0;
          end else Horloge.Enabled:=true;
     end;
     if Horloge.Tag=0 then Close;
end;

end.
