{******************************************************************************}
{   Unit/Unit CheckGroupBox                                                   }
{                                                                              }
{   Sorry for my very bad english :-)                                          }
{                                                                              }
{ TCheckGroupBox :                                                             }
{   TGroupBox qui intgre une TCheckBox et qui permet d'activer ou de          }
{   dsactiver les contrles enfants du GroupBox.                              }
{   TGroupBox which integrates TCheckBox and which makes it possible to        }
{   enable or disable child controls of the GroupBox.                          }
{                                                                              }
{   Proprits/Properties :                                                    }
{     - Caption: string                                                        }
{         Caption du checkbox.                                                 }
{         CheckBox Caption.                                                    }
{     - BoxAlignment: TLeftRight                                               }
{         Identique  la proprit Alignment d'un TCheckBox                    }
{         identical to the Alignment property of TCheckBox                     }
{     - Checked: boolean                                                       }
{         Proprit Checked du TCheckBox.                                      }
{         Checked property of TCheckBox.                                       }
{     - CheckBox: TXCheckBox (Public property)                                 }
{         Disponible uniquement  l'excution pour accder  d'autres          }
{         proprits de la CheckBox ou programmer d'autres vnements, voir    }
{         la dclaration de TXCheckBox ci-dessous pour la liste des proprits }
{         publies.                                                            }
{         Available only at runtime to reach others properties of CheckBox or  }
{         to program other events, see below the TXCheckBox declaration for    }
{         the list of published properties.                                    }
{     - CheckedEnables: boolean                                                }
{         Dsactive les contrles enfants quand la CheckBox est active.       }
{         Deactivate children controls when CheckBox is activated.             }
{   Evenements/Events :                                                        }
{     - OnCheckBoxClick: TNotifyEvent                                          }
{         Se produit aprs avoir cliqu sur la CheckBox et aprs que les       }
{         contrles soit activs ou dsactivs.                                }
{         Occurs after having clicked on CheckBox and after the controls is    }
{         enabled or desabled.                                                 }
{                                                                              }
{                                                                              }
{  COPYRIGHT / GARANTIE                                                        }
{                                                                              }
{ Ce composant est un gratuiciel et donc libre de droits. Il est fourni        }
{ TEL QUEL, sans aucune garantie expresse ou tacite, pour quelque raison       }
{ que ce soit, y compris d'ventuels dommages causs par l'utilisation de ce   }
{ composant, les dommages pour pertes de profits, cessation d'activites        }
{ commerciales ou autre.                                                       }
{ Vous pouvez utiliser ce composant comme bon vous semble, except pour une    }
{ utilisation commerciale, c'est  dire ne pas utiliser tout ou  partie de ce  }
{ composants dans un projet commercial (Dans ce cas le paiement d'une modeste  }
{ licence vous sera demand - contactez moi pour les prcisions).              }
{ Vous ne pouvez pas prtendre avoir crit ces composants et vous n'tes pas   }
{ autoris  supprimer l'en-tte du fichier source (question d'thique).       }
{ Si vous n'tes pas en accord avec ce qui prcde, ne l'utilisez pas.         }
{                                                                              }
{ Donc, si vous modifiez ou amliorez ce composant, laissez intacte l'en-tte  }
{ de ce fichier et ajoutez vos commentaires  la fin de cet l'en-tte.         }
{ Tous commentaires et/ou suggestions, rapport de bug, seront apprcis.       }
{ Si vous l'utilisez dans un projet, merci de mentionner mon nom et mon        }
{ adresse E-Mail.                                                              }
{                                                                              }
{  COPYRIGHT/ LIMITED WARRANTY                                                 }
{                                                                              }
{  THIS COMPONENT IS FREEWARE AND PROVIDED 'AS IS' WITHOUT WARRANTIES OF ANY   }
{  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED }
{  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.         }
{  THE AUTHOR DOESN'T ASSUME ANY RESPONSIBILITY FOR ANY DAMAGE OR ANY LOOSE OF }
{  TIME OR MONEY DUE THE USE OF ANY PART OF THIS COMPONENT. THE AUTHOR SHALL   }
{  NOT BE LIABLE FOR INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS PROFITS OR    }
{  SPECIAL OR INDIRECT DAMAGES OF ANY SORT, WHETHER ARISING IN TORT, CONTRACT  }
{  OR OTHERWISE, EVEN IF THE AUTHOR HAS BEEN INFORMED OF THE POSSIBILITY OF    }
{  SUCH DAMAGES.                                                               }
{                                                                              }
{  THE AUTHOR ARE SURE YOU KNOW THAT A NULL-COST FREE SOFTWARE DOES NOT        }
{  PROVIDE ANY WARRANTIES.                                                     }
{  IF YOU DON'T AGREE THIS TERMS, DON'T USE THIS COMPONENT.                    }
{                                                                              }
{  You can use this component as you want, EXCEPT FOR A COMMERCIAL USE (what   }
{  obliges the payment of a weak licence).                                     }
{  You cannot claim to have written these components and you are NOT authorized}
{  to remove the heading of source file (ethics problem).                      }
{                                                                              }
{  If you modify the source or make corrections or additions, add simply your  }
{  comments, a description and your name at the end of heading. In that case   }
{  thank you to send me a copy of your modifications.                          }
{                                                                              }
{  You can send me an e-mail with a bugs list, a request for modification or   }
{  development of new functionalities.                                         }
{  Generally, all comments or suggestions will be appreciated. Please, tell me }
{  what you do with this component, or simply Hello, I like your component.    }
{  If you use it in a project, thank's to mention my name and my               }
{  E-Mail addresses.                                                           }
{                                                                              }
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ email : jmbo@softhome.net                                                    }
{ See other components at http://www.chez.com/jmbo/index.html                  }
{                                                                              }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.0.0                                                              }
{ Cration/Creation : 27/04/1999                                               }
{                                                                              }
{ Cration de TCheckGroupBox, (dvelopp pour Renbatch V2.0)                   }
{ Creation of TCheckGroupBox, (developed for Renbatch V2.0)                    }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.1.0                                                              }
{ Date : 04/05/1999                                                            }
{                                                                              }
{ Changements mineurs.                                                         }
{ Some minor changes.                                                          }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON   (at the request of John Knipper)       }
{ Version : 1.2.0                                                              }
{ Date : 16/06/1999                                                            }
{                                                                              }
{ - Modifications pour que les contrles enfants soit griss quand la case    }
{   cocher est dsactive ou quand la CheckGroupBox elle-mme est dsactive,  }
{   ( la demande de john Knipper).                                            }
{ - Modifications so that child controls is grayed when the checkbox is        }
{   disabled or when CheckGroupBox itself is disabled,                         }
{                                                                              }
{------------------------------------------------------------------------------}
{ Auteur/Author : Greg Bullock, bullock@mrcmry.com                             }
{                 ( Adaptation Jean-Michel BOUCTON )                           }
{ Version : 1.3.0                                                              }
{ Date : 30/08/1999                                                            }
{                                                                              }
{ Le code crit par Greg a t ajout  la version 1.0, aussi je l'ai adapt   }
{ pour la version 1.2.  Jean-Michel)                                           }
{                                                                              }
{ - Ajout de la proprit CheckedEnables pour permettre l'action oppose :     }
{   dsactiver les contrles enfants quand la CheckBox est active.            }
{   Addition of CheckedEnables property to allow the opposite behavior :       }
{   Disabling the child components when the CheckBox is checked.               }
{ - Suppression du champ FChecked et ajout de la mthode GetChecked.           }
{   Elimination of the FChecked field and addition of the GetChecked method.   }
{ - Correction d'un bug quand la taille de la fonte change. (Jean-Michel)      }
{   Fix bug when the font size changes. (Jean-Michel)                          }
{------------------------------------------------------------------------------}
{ Auteur/Author :                                                              }
{ Version :                                                                    }
{ Date :                                                                       }
{                                                                              }
{******************************************************************************}
unit CheckGroupBox;

interface
//{$D-}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, THemes;

type
  TXCheckBox = class(TCustomCheckBox)
  published
    property AllowGrayed;
    property Color;
    property Ctl3D;
    property Enabled;
    property ShowHint;
    property State;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TCheckCustomGroupBox = class(TCustomGroupBox)
  private
    FCaption: string;
    FCheckBox: TXCheckBox;
    FCheckedEnables: boolean;
    FAutoEnableComponents: boolean;
    FOnCheckBoxClick: TNotifyEvent;
    FEnable: boolean;
    function GetAlignment: TLeftRight;
    procedure SetAlignment(Value: TLeftRight);
    function GetCaption: TCaption;
    procedure SetCaption(Value: TCaption);
    procedure AdjustCheckBounds;
    function GetChecked: boolean;
    procedure SetChecked(Value: boolean);
    procedure WMENABLE(var Message: TWMEnable); message WM_ENABLE;
    procedure SetCheckedEnables(Value: boolean);
    function GetEnable: boolean;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
  protected
     function GetEnabled : Boolean; override;
     procedure SetEnabled (Value: Boolean); override;
     procedure UpdateChilds;
    procedure EnableControls(WControl: TWinControl; var Message: TWMEnable); virtual;
    procedure CreateWnd; override;
    procedure Paint; override;
    procedure CheckBoxClick(Sender: TObject); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property CheckBox: TXCheckBox read FCheckBox write FCheckBox;
    property Enable: boolean read GetEnable write FEnable;
  published
    property Enabled : Boolean read GetEnabled write SetEnabled;
    property BoxAlignment: TLeftRight read GetAlignment write SetAlignment;
    property Caption: TCaption read GetCaption write SetCaption;
    property Checked: boolean read GetChecked write SetChecked;
    property CheckedEnables: boolean read FCheckedEnables write SetCheckedEnables default true;
    property AutoEnableComponents: boolean read FAutoEnableComponents write FAutoEnableComponents default true;
    property OnCheckBoxClick: TNotifyEvent read FOnCheckBoxClick write FOnCheckBoxClick;
  end;

  TCheckGroupBox = class(TCheckCustomGroupBox)
  published
    property Align;
    property Anchors;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;
  
  procedure Register;

const
  BoxWith = 19;

implementation

procedure Register;
begin
  RegisterComponents('Standard', [TCheckGroupBox]);
end;

constructor TCheckCustomGroupBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCheckedEnables := true;
  FCheckBox := TXCheckBox.Create(Self);
  FCaption:='';
  FAutoEnableComponents:=true;
  with FCheckBox do
  begin
    Parent := Self;
    OnClick := CheckBoxClick;
    Checked := true;
    Left := 6;
    Width := 18;
    inherited Top := 0;
    Caption := '';
  end;
end;

destructor TCheckCustomGroupBox.Destroy;
begin
  FCheckBox.Free;
  inherited Destroy;
end;

function TCheckCustomGroupBox.GetEnabled: Boolean;
begin Result := inherited GetEnabled; end;

procedure TCheckCustomGroupBox.SetEnabled (Value: Boolean);
begin inherited SetEnabled (Value); end;

procedure TCheckCustomGroupBox.UpdateChilds;
var X : Integer;
begin
     for X := 0 to Self.ControlCount - 1 do
     if not Enabled then Self.Controls[X].Enabled := Enabled
     else
     Self.Controls[X].Enabled := (Self.Controls[x] is TXCheckBox)
                              or (Checked and AutoEnableComponents);
end;

procedure TCheckCustomGroupBox.CreateWnd;
begin
  inherited;
  if Caption = '' then
    inherited Text := '';
end;

procedure TCheckCustomGroupBox.WMENABLE(var Message: TWMEnable);
begin
     inherited;
     UpdateChilds;
end;

function TCheckCustomGroupBox.GetAlignment: TLeftRight;
begin
  Result := FCheckBox.Alignment;
end;

procedure TCheckCustomGroupBox.SetAlignment(Value: TLeftRight);
begin
  FCheckBox.Alignment := Value;
end;

function TCheckCustomGroupBox.GetCaption: TCaption;
begin Result:=FCaption; end;

procedure TCheckCustomGroupBox.SetCaption(Value: TCaption);
begin
  if (FCheckBox.Left + Canvas.TextWidth(Value) + BoxWith) < Width then
  begin
    FCheckBox.Caption := Value;
    FCaption:=Value;
    AdjustCheckBounds;
  end;
end;

procedure TCheckCustomGroupBox.CMFontChanged(var Message: TMessage);
begin
  inherited;
  Canvas.Font := Self.Font;
  FCheckBox.Height := Canvas.TextHeight('ZZ');
  FCheckBox.Top := 0;
  AdjustCheckBounds;
end;

procedure TCheckCustomGroupBox.AdjustCheckBounds;
const
  WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);
begin
  // Par dfaut La Font du checkbox est celle de son parent
  FCheckBox.Width := BoxWith + Canvas.TextWidth(FCheckBox.Caption) + 2;
  FCheckBox.Repaint;
end;

function TCheckCustomGroupBox.GetChecked: boolean;
begin
  Result := FCheckBox.Checked;
end;

procedure TCheckCustomGroupBox.SetChecked(Value: boolean);
begin
  FCheckBox.Checked := Value;
  CheckBoxClick(nil);
end;

procedure TCheckCustomGroupBox.SetCheckedEnables(Value: boolean);
begin
  FCheckedEnables := Value;
  if Enabled then
    CheckBoxClick(nil);
end;

function TCheckCustomGroupBox.GetEnable: boolean;
begin
  Result := FCheckBox.Checked xor not FCheckedEnables;
end;

procedure TCheckCustomGroupBox.CheckBoxClick(Sender: TObject);
var
  i: integer;
  Enbl: boolean;
begin
  inherited Click;
  Enbl:= Enable;
  if FAutoEnableComponents then
  for i := 0 to ControlCount - 1 do
  begin
    if Controls[i] is TXCheckBox then
      continue;
    Controls[i].Enabled := Enbl;
  end;
  if Assigned(FOnCheckBoxClick) then FOnCheckBoxClick(Self);
end;

procedure TCheckCustomGroupBox.EnableControls(WControl: TWinControl; var Message: TWMEnable);
var
  i: integer;
begin
  if not (csDesigning in ComponentState) then
    if WControl.controlcount > 0 then
    begin
      if (WControl = Self) then
        if (not Enabled) and (not Enable) and  (not Message.Enabled) then
          Self.FCheckBox.Enabled := false  // Pour griser aussi la checkbox
        else                               // quand le contrle est dsactiv
        begin
          Self.FCheckBox.Enabled := true;
        end;
      for i := 0 to WControl.ControlCount - 1 do
        if (WControl.Controls[i] is TWinControl) and Enable then
        begin
            EnableControls(TWinControl(WControl.Controls[i]), Message);
        end;
    end else
      if WControl.HandleAllocated then
        if (WControl.Parent is TCheckCustomGroupBox) and
           not (WControl.Parent as TCheckCustomGroupBox).Enable then
        begin
          if (WControl is TXCheckbox) and WControl.Parent.Enabled then
            WControl.Enabled := Message.Enabled;
        end else
          WControl.Enabled := Message.Enabled;
end;


procedure TCheckCustomGroupBox.Paint;
var
  H: Integer;
  R: TRect;
  Flags: Longint;
  CaptionRect,
  OuterRect: TRect;
  Size: TSize;
  Box: TThemedButton;
  Details: TThemedElementDetails;
begin
  with Canvas do
  begin
    Font := Self.Font;
    FCheckBox.Doublebuffered:=DoubleBuffered;
    if ThemeServices.ThemesEnabled then
    begin
      Text:=FCaption;
      if Text <> '' then
      begin
        GetTextExtentPoint32(Handle, PChar(Text), Length(Text), Size);
        CaptionRect := Rect(14, 0, Size.cx+14, Size.cy);
        if not UseRightToLeftAlignment then
          OffsetRect(CaptionRect, 8, 0)
        else
          OffsetRect(CaptionRect, Width - 8 - CaptionRect.Right, 0);
      end
      else
        CaptionRect := Rect(0, 0, 0, 0);

      OuterRect := ClientRect;
      OuterRect.Top := (CaptionRect.Bottom - CaptionRect.Top) div 2;
      with CaptionRect do
        ExcludeClipRect(Handle, Left, Top, Right, Bottom);
      if Enabled then
        Box := tbGroupBoxNormal
      else
        Box := tbGroupBoxDisabled;
      Details := ThemeServices.GetElementDetails(Box);
      ThemeServices.DrawElement(Handle, Details, OuterRect);

      SelectClipRgn(Handle, 0);
      if Text <> '' then
        ThemeServices.DrawText(Handle, Details, Text, CaptionRect, DT_LEFT, 0);
      FCheckbox.Caption:='';
    end
    else
    begin
      H := TextHeight('0');
      R := Rect(0, H div 2 - 1, Width, Height);
      if Ctl3D then
      begin
        Inc(R.Left);
        Inc(R.Top);
        Brush.Color := clBtnHighlight;
        FrameRect(R);
        OffsetRect(R, -1, -1);
        Brush.Color := clBtnShadow;
      end else
        Brush.Color := clWindowFrame;
      FrameRect(R);
      if Text <> '' then
      begin
        if not UseRightToLeftAlignment then
          R := Rect(8, 0, 0, H)
        else
          R := Rect(R.Right - Canvas.TextWidth(Text) - 8, 0, 0, H);
        Flags := DrawTextBiDiModeFlags(DT_SINGLELINE);
        DrawText(Handle, PChar(Text), Length(Text), R, Flags or DT_CALCRECT);
        Brush.Color := Color;
        DrawText(Handle, PChar(Text), Length(Text), R, Flags);
      end;
    end;
  end;
end;

end.
