unit Principale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, CheckGroupBox, StdCtrls, ComCtrls, IniFiles, WinInet, ShellAPI,
  ValEdit, Grids, Buttons, ColorButton, Commun, Registry, TaskScheduler,
  GIFImage, DirBrowseDialog;

type
  TValueListEditor = class(ValEdit.TValueListEditor)
  public
    TempValue: string;
    procedure DoOnValidate; override;
  end;

  TGeneral = record
    Mode: byte;
    Fenetre: bool;
    Fenetre_Ouverte: bool;
    Log: bool;
    Stopper: bool;
    AfficherMessage: bool;
    Stopper_Minutes: integer;
    Stopper_Installation : bool;
    Stopper_Installation_Minutes: integer;
    Proxy: bool;
    Proxy_Adresse: string;
    UpdateSoft: bool;
  end;
  TFlash = record
    Actif: bool;
    Update: byte;
    Modules: byte;
    Installe: bool;
    Exclusions: TStringList;
  end;
  TIndex_Education = record
     Actif: bool;
     Logiciels : byte;
     Modules: byte;
     Update: bool;
     Dossier_Pronote32, Dossier_Pronote64, Dossier_EDT32, Dossier_EDT64: string;
  end;
  TJava = record
    Actif: bool;
    Update: byte;
    Modules: byte;
    Securite: byte;
    Desinstalle: bool;
    Installe: bool;
    Sites_Autorisation: byte;
    Exclusions, Sites: TStringList;
  end;
  TFirefox_Configuration_Item = record
    Key, Value: string;
  end;
  TFirefox = record
    Actif: bool;
    Config: array of TFirefox_Configuration_Item;
    Installe: bool;
    ESR: bool;
    Modules: byte;
  end;
  TThunderbird_Configuration_Item = record
    Key, Value: string;
  end;
  TThunderbird = record
    Actif: bool;
    Config: array of TThunderbird_Configuration_Item;
    Installe: bool;
//    ESR: bool;
    Modules: byte;
  end;
  TVLC = record
    Actif: bool;
    Update: byte;
    Modules: byte;
    Installe: bool;
  end;
  TAIR = record
    Actif: bool;
    Update: byte;
    Installe: bool;
  end;
  TOS = record
    Win_XP, Win_2003, Win_Vista, Win_7, Win_8, Win_2008, Win_2012, Win_10, Win_11: bool;
  end;
  TConfiguration = record
    Fichier: TFileName;
    General: TGeneral;
    Flash: TFlash;
    Firefox: TFirefox;
    Thunderbird: TThunderbird;
    VLC: TVLC;
    AIR: TAIR;
    Index_Education: TIndex_Education;
    Java: TJava;
    Modifie: bool;
    OS: TOS;
  end;
  TFicheUpdateSoft = class(TForm)
    Classeur: TPageControl;
    PageGeneral: TTabSheet;
    PageFlash: TTabSheet;
    PageJava: TTabSheet;
    PageFirefox: TTabSheet;
    Flash: TCheckGroupBox;
    Java: TCheckGroupBox;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    Enregistrersous1: TMenuItem;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Ouvrir: TOpenDialog;
    Enregistrer: TSaveDialog;
    N2: TMenuItem;
    N3: TMenuItem;
    Tester: TMenuItem;
    Nouveau: TMenuItem;
    Misejourdisponible: TMenuItem;
    HorlogeMAJ: TTimer;
    PageVLC: TTabSheet;
    VLC: TCheckGroupBox;
    VLCPanel0: TPanel;
    PageAIR: TTabSheet;
    AIR: TCheckGroupBox;
    AIRPanel: TPanel;
    AIR_Installe: TCheckBox;
    AIR_Update: TRadioGroup;
    Firefox: TCheckGroupBox;
    Firefox_Classeur: TPageControl;
    PageFirefox_General: TTabSheet;
    PageFirefox_Configuration: TTabSheet;
    Firefox_Configuration: TValueListEditor;
    PageFirefox_Telechargement: TTabSheet;
    Firefox_Panel: TPanel;
    Firefox_Box3: TCheckBox;
    Firefox_Box1: TCheckBox;
    Firefox_Installe: TCheckBox;
    Firefox_PanelCache: TPanel;
    Firefox_Box0: TCheckBox;
    Firefox_ESR2: TCheckBox;
    Java_Classeur: TPageControl;
    Java_General: TTabSheet;
    Java_Panel: TPanel;
    Java_Modules: TRadioGroup;
    JavaPanel: TPanel;
    Panel3: TPanel;
    Java_Installe: TCheckBox;
    Panel8: TPanel;
    Java_Securite: TRadioGroup;
    Java_Update: TRadioGroup;
    Java_Exclusions: TTabSheet;
    Flash_Classeur: TPageControl;
    Flash_General: TTabSheet;
    Flash_Exclusions: TTabSheet;
    Flash_Panel: TPanel;
    Flash_Modules: TRadioGroup;
    FlashPanel: TPanel;
    Flash_Update: TRadioGroup;
    Panel6: TPanel;
    Flash_Installe: TCheckBox;
    Flash_Exclusions_Liste: TListBox;
    Flash_Exclusions_Nouveau: TEdit;
    Panel9: TPanel;
    Flash_Exclusions_Info: TLabel;
    Flash_Exclusions_Ajouter: TSpeedButton;
    Panel10: TPanel;
    Java_Exclusions_Info: TLabel;
    Java_Exclusions_Liste: TListBox;
    Java_Exclusions_Nouveau: TEdit;
    Java_Exclusions_Ajouter: TSpeedButton;
    PageThunderbird: TTabSheet;
    Thunderbird: TCheckGroupBox;
    Thunderbird_Classeur: TPageControl;
    PageThunderbird_General: TTabSheet;
    Thunderbird_Panel: TPanel;
    Thunderbird_Box1: TCheckBox;
    Thunderbird_Installe: TCheckBox;
    Thunderbird_Box0: TCheckBox;
    PageThunderbird_Configuration: TTabSheet;
    Thunderbird_Configuration: TValueListEditor;
    PageThunderbird_Telechargement: TTabSheet;
    Panel13: TPanel;
    Thunderbird_ESR2: TCheckBox;
    Firefox_Box2: TCheckBox;
    Java_Desinstalle: TCheckBox;
    Java_Sites: TTabSheet;
    Java_Sites_Nouveau: TEdit;
    Java_Sites_Ajouter: TSpeedButton;
    Java_Sites_Liste: TListBox;
    Panel1: TPanel;
    Java_Sites_Info: TLabel;
    Java_Sites_0: TRadioButton;
    Java_Sites_1: TRadioButton;
    Java_Sites_2: TRadioButton;
    ClasseurSecondaire: TPageControl;
    PageFonctionnement: TTabSheet;
    PageService: TTabSheet;
    Panel5: TPanel;
    General_Mode: TRadioGroup;
    Panel4: TPanel;
    General_Mode_Info: TLabel;
    Panel7: TPanel;
    Panel12: TPanel;
    Service_Info: TLabel;
    Service_Tester: TSpeedButton;
    Service_Installer: TSpeedButton;
    Service_Desinstaller: TSpeedButton;
    Service_Programmation_Groupe: TGroupBox;
    Service_Programmation_Label: TLabel;
    Service_Programmation_Heure: TDateTimePicker;
    Service_Programmation_Actif: TRadioButton;
    Service_Programmation_Inactif: TRadioButton;
    Service_Ouvrir: TOpenDialog;
    Groupe_Proxy: TGroupBox;
    Groupe_Proxy_Image: TImage;
    Groupe_Proxy_Infos: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Firefox_ESR: TCheckBox;
    Thunderbird_ESR: TCheckBox;
    ClasseurService: TPageControl;
    PageServicePartage: TTabSheet;
    Service_Chemin_Label: TLabel;
    Service_Chemin: TEdit;
    Service_Chemin_Selection: TSpeedButton;
    Service_Script_Label: TLabel;
    Service_Script: TEdit;
    Service_Script_Selection: TSpeedButton;
    Service_Nom_Label: TLabel;
    Service_Nom: TEdit;
    Service_Password_Label: TLabel;
    Service_Password: TEdit;
    PageServiceContexte: TTabSheet;
    Service_Contexte_Systeme: TRadioButton;
    Service_Contexte_Compte: TRadioButton;
    Service_Contexte_Label: TLabel;
    Service_Contexte_Compte_Groupe: TGroupBox;
    Service_Contexte_Compte_Nom_Label: TLabel;
    Service_Contexte_Compte_Nom: TEdit;
    Service_Contexte_Compte_Password: TEdit;
    Service_Contexte_Compte_Password_Label: TLabel;
    Classeur3: TPageControl;
    PageOptionsGenerales: TTabSheet;
    Signe: TLabel;
    General_Box1: TCheckBox;
    General_Box2: TCheckBox;
    General_Box3: TCheckBox;
    General_Box4: TCheckBox;
    General_Updown: TEdit;
    General_Updown2: TUpDown;
    General_Box5: TCheckBox;
    General_Proxy1: TRadioButton;
    General_Proxy2: TRadioButton;
    General_Proxy_Adresse: TEdit;
    General_Box6: TCheckBox;
    PageOS: TTabSheet;
    General_Windows_XP: TCheckBox;
    General_Windows_Vista: TCheckBox;
    General_Windows_10: TCheckBox;
    Label3: TLabel;
    General_Windows_2003: TCheckBox;
    General_Windows_7: TCheckBox;
    General_Windows_2008: TCheckBox;
    General_Windows_2012: TCheckBox;
    General_Windows_8: TCheckBox;
    VLC_Modules: TRadioGroup;
    VLCPanel: TPanel;
    VLC_Update: TRadioGroup;
    VLC_Installe: TCheckBox;
    Thunderbird_Modules: TRadioGroup;
    Firefox_Modules: TRadioGroup;
    Firefox_Modules2: TRadioGroup;
    Thunderbird_Modules2: TRadioGroup;
    PageIndex_Education: TTabSheet;
    Index_Education: TCheckGroupBox;
    Panel15: TPanel;
    Panel16: TPanel;
    Index_Education_Logiciels: TRadioGroup;
    Index_Education_Modules: TRadioGroup;
    Dossier_Selection: TDirBrowseDialog;
    Index_EducationPanel: TPanel;
    Index_Education_Dossier_Pronote32: TEdit;
    Index_Education_Dossier_Pronote32_Selection: TButton;
    Index_Education_Dossier_Pronote32_Label: TLabel;
    Index_Education_Dossier_Infos: TLabel;
    Index_Education_Dossier_Pronote64_Label: TLabel;
    Index_Education_Dossier_Pronote64: TEdit;
    Index_Education_Dossier_Pronote64_Selection: TButton;
    Index_Education_Update: TCheckBox;
    Index_Education_Dossier_EDT32_Label: TLabel;
    Index_Education_Dossier_EDT32: TEdit;
    Index_Education_Dossier_EDT32_Selection: TButton;
    Index_Education_Dossier_EDT64_Label: TLabel;
    Index_Education_Dossier_EDT64: TEdit;
    Index_Education_Dossier_EDT64_Selection: TButton;
    General_Windows_11: TCheckBox;
    General_Box7: TCheckBox;
    General_Updown3: TEdit;
    General_Updown4: TUpDown;
    procedure General_ModeClick(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TesterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure General_Updown2Click(Sender: TObject; Button: TUDBtnType);
    procedure NouveauClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HorlogeMAJTimer(Sender: TObject);
    procedure MisejourdisponibleClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Firefox_ConfigurationKeyPress(Sender: TObject;
      var Key: Char);
    procedure Firefox_ConfigurationValidate(Sender: TObject; ACol,
      ARow: Integer; const KeyName, KeyValue: String);
    procedure Firefox_ConfigurationStringsChange(Sender: TObject);
    procedure Firefox_ConfigurationGetEditText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure Firefox_Box1Click(Sender: TObject);
    procedure Firefox_Box2Click(Sender: TObject);
    procedure Firefox_Box3Click(Sender: TObject);
    procedure PageFirefox_ConfigurationShow(Sender: TObject);
    procedure Firefox_ConfigurationEnter(Sender: TObject);
    procedure Firefox_Box0Click(Sender: TObject);
    procedure Firefox_ESR2Click(Sender: TObject);
    procedure Firefox_ESRClick(Sender: TObject);
    procedure Flash_Exclusions_NouveauChange(Sender: TObject);
    procedure Flash_Exclusions_NouveauKeyPress(Sender: TObject;
      var Key: Char);
    procedure Flash_Exclusions_AjouterClick(Sender: TObject);
    procedure Flash_Exclusions_ListeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ClasseurDrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure Thunderbird_Box0Click(Sender: TObject);
    procedure Thunderbird_Box1Click(Sender: TObject);
    procedure Thunderbird_ESRClick(Sender: TObject);
    procedure Thunderbird_ConfigurationStringsChange(Sender: TObject);
    procedure Thunderbird_ConfigurationKeyPress(Sender: TObject;
      var Key: Char);
    procedure Thunderbird_ConfigurationGetEditText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure Thunderbird_ConfigurationEnter(Sender: TObject);
    procedure Thunderbird_ConfigurationValidate(Sender: TObject; ACol,
      ARow: Integer; const KeyName, KeyValue: String);
    procedure PageThunderbird_ConfigurationShow(Sender: TObject);
    procedure Thunderbird_ESR2Click(Sender: TObject);
    procedure Java_Sites_ListeMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure Java_Sites_ListeClick(Sender: TObject);
    procedure Java_Exclusions_ListeClick(Sender: TObject);
    procedure Flash_Exclusions_ListeClick(Sender: TObject);
    procedure Service_Chemin_SelectionClick(Sender: TObject);
    procedure Service_Script_SelectionClick(Sender: TObject);
    procedure Service_TesterClick(Sender: TObject);
    procedure Service_CheminChange(Sender: TObject);
    procedure Service_Programmation_InactifClick(Sender: TObject);
    procedure Service_Contexte_Compte_GroupeEnter(Sender: TObject);
    procedure Service_CheminExit(Sender: TObject);
    procedure Service_Contexte_SystemeClick(Sender: TObject);
    procedure Firefox_Modules2Click(Sender: TObject);
    procedure Firefox_ModulesClick(Sender: TObject);
    procedure Thunderbird_Modules2Click(Sender: TObject);
    procedure Thunderbird_ModulesClick(Sender: TObject);
    procedure Index_Education_Dossier_Pronote32_SelectionClick(Sender: TObject);
    procedure Index_Education_Dossier_Pronote64_SelectionClick(Sender: TObject);
    procedure Index_Education_Dossier_EDT32_SelectionClick(
      Sender: TObject);
    procedure Index_Education_Dossier_EDT64_SelectionClick(
      Sender: TObject);
    procedure Index_Education_Dossier_Pronote32Exit(Sender: TObject);
  private
    procedure Thunderbird_BoxClick(State: bool; Key, Value: string ; const FollowClick: bool=true ; const DeleteIfNotExists: bool=true);
    procedure Firefox_BoxClick(State: bool; Key, Value: string ; const FollowClick: bool=true ; const DeleteIfNotExists: bool=true);
    procedure ComposantsVersConfiguration;
    procedure ConfigurationVersComposants;
    procedure EnregistrerConfiguration(FileName: TFileName);
    function EnregistrerConfigurationSous: bool;
    function FermerConfiguration: bool;
    procedure ActualiserComposantsService(ToutDesactiver: bool=false);
    procedure MenuItemAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; State: TOwnerDrawState);
    procedure AjusterCheckBox(CheckBox: TCheckBox);
    procedure AjusterRadioButton(RadioButton: TRadioButton);
  public
  end;

  TMAJThread = class(TThread)
  protected
    procedure Execute; override;
  public
    procedure FinThread;
  end;

var
  FicheUpdateSoft: TFicheUpdateSoft;
  Configuration: TConfiguration;
  MAJThread: TMAJThread;
  URLDownloadNewVersion: string='';

procedure LireConfiguration(var _Configuration: TConfiguration ; FileName: TFileName);

implementation

uses APropos, Fonctions, Fonctions_VLC, Fonctions_UpdateSoft, Fonctions_Firefox, Math,
  Attente;

{$R *.dfm}

procedure AddFirefoxConfiguration(var _Configuration: TConfiguration ; _Key, _Value: string);
var Trouve: bool;
    i, j: integer;
begin
     with _Configuration.Firefox do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then Config[i].Value:=Trim(_Value)
          else
          begin
               i:=0; while (i<length(Config)) and (CompareText(Config[i].Key, _Key)<0) do Inc(i);
               Setlength(Config, length(Config)+1);
               for j:=length(Config)-2 downto i do Config[j+1]:=Config[j];
               with Config[i] do begin Key:=Trim(_Key); Value:=Trim(_Value); end;
          end;
     end;
end;

procedure DelFirefoxConfiguration(var _Configuration: TConfiguration ; _Key: string);
var Trouve: bool;
    i, j: integer;
begin
     with _Configuration.Firefox do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then
          begin
               for j:=i+1 to length(Config)-1 do
               Config[j-1]:=Configuration.Firefox.Config[j];
               Setlength(Config, length(Config)-1);
          end;
     end;
end;

function GetFirefoxConfiguration(var _Configuration: TConfiguration ; _Key: string): string;
var Trouve: bool;
    i: integer;
begin
     with _Configuration.Firefox do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then result:=Config[i].Value else result:='';
     end;
end;

procedure AddThunderbirdConfiguration(var _Configuration: TConfiguration ; _Key, _Value: string);
var Trouve: bool;
    i, j: integer;
begin
     with _Configuration.Thunderbird do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then Config[i].Value:=Trim(_Value)
          else
          begin
               i:=0; while (i<length(Config)) and (CompareText(Config[i].Key, _Key)<0) do Inc(i);
               Setlength(Config, length(Config)+1);
               for j:=length(Config)-2 downto i do Config[j+1]:=Config[j];
               with Config[i] do begin Key:=Trim(_Key); Value:=Trim(_Value); end;
          end;
     end;
end;

procedure DelThunderbirdConfiguration(var _Configuration: TConfiguration ; _Key: string);
var Trouve: bool;
    i, j: integer;
begin
     with _Configuration.Thunderbird do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then
          begin
               for j:=i+1 to length(Config)-1 do
               Config[j-1]:=Configuration.Thunderbird.Config[j];
               Setlength(Config, length(Config)-1);
          end;
     end;
end;

function GetThunderbirdConfiguration(var _Configuration: TConfiguration ; _Key: string): string;
var Trouve: bool;
    i: integer;
begin
     with _Configuration.Thunderbird do
     begin
          Trouve:=false; i:=0;
          while not Trouve and (i<length(Config)) do
             if SameText(Trim(Config[i].Key), Trim(_Key)) then Trouve:=true else Inc(i);
          if Trouve then result:=Config[i].Value else result:='';
     end;
end;

procedure TFicheUpdateSoft.ComposantsVersConfiguration;
begin
     with Configuration do
     begin
          with General do
          begin
               Mode:=General_Mode.ItemIndex;
               Fenetre:=General_Box1.Checked;
               Fenetre_Ouverte:=General_Box2.Checked;
               AfficherMessage:=General_Box6.Checked;
               Log:=General_Box3.Checked;
               Stopper:=General_Box4.Checked;
               Stopper_Minutes:=General_Updown2.Position;
               Stopper_Installation:=General_Box7.Checked;
               Stopper_Installation_Minutes:=General_Updown4.Position;
               UpdateSoft:=General_Box5.Checked;
               Proxy:=General_Proxy2.Checked;
               Proxy_Adresse:=General_Proxy_Adresse.Text;
          end;
          with Flash do
          begin
               Actif:=FicheUpdateSoft.Flash.Checked;
               Update:=Flash_Update.ItemIndex;
               Modules:=Flash_Modules.ItemIndex;
               Installe:=Flash_Installe.Checked;
               Exclusions.Clear;
               Exclusions.AddStrings(Flash_Exclusions_Liste.Items);
          end;
          with Index_Education do
          begin
               Actif:=FicheUpdateSoft.Index_Education.Checked;
               Logiciels:=Index_Education_Logiciels.ItemIndex;
               Modules:=Index_Education_Modules.ItemIndex;
               Update:=Index_Education_Update.Checked;
               Dossier_Pronote32:=Index_Education_Dossier_Pronote32.Text;
               Dossier_Pronote64:=Index_Education_Dossier_Pronote64.Text;
               Dossier_EDT32:=Index_Education_Dossier_EDT32.Text;
               Dossier_EDT64:=Index_Education_Dossier_EDT64.Text;
          end;
          with Java do
          begin
               Actif:=FicheUpdateSoft.Java.Checked;
               Update:=Java_Update.ItemIndex;
               Modules:=Java_Modules.ItemIndex;
               Securite:=Java_Securite.ItemIndex;
               Desinstalle:=Java_Desinstalle.Checked;
               Installe:=Java_Installe.Checked;
               Exclusions.Clear;
               Exclusions.AddStrings(Java_Exclusions_Liste.Items);
               if Java_Sites_0.Checked then Sites_Autorisation:=0 else
               if Java_Sites_1.Checked then Sites_Autorisation:=1 else Sites_Autorisation:=2;
               Sites.Clear;
               Sites.AddStrings(Java_Sites_Liste.Items);
          end;
          with Firefox do
          begin
               Actif:=FicheUpdateSoft.Firefox.Checked;

               if Firefox_Box0.Checked then
               begin
                    AddFirefoxConfiguration(Configuration, 'app.update.auto', 'false');
                    AddFirefoxConfiguration(Configuration, 'app.update.enabled', 'false');
               end
               else
               begin
                    DelFirefoxConfiguration(Configuration, 'app.update.auto');
                    DelFirefoxConfiguration(Configuration, 'app.update.enabled');
               end;

               if Firefox_Box1.Checked then
               begin
                    AddFirefoxConfiguration(Configuration, 'extensions.update.enabled', 'false');
                    AddFirefoxConfiguration(Configuration, 'extensions.update.autoUpdateDefault', 'false');
               end
               else
               begin
                    DelFirefoxConfiguration(Configuration, 'extensions.update.enabled');
                    DelFirefoxConfiguration(Configuration, 'extensions.update.autoUpdateDefault');
               end;

               if Firefox_Box2.Checked then AddFirefoxConfiguration(Configuration, 'browser.startup.homepage_override.mstone', 'ignore')
                                       else DelFirefoxConfiguration(Configuration, 'browser.startup.homepage_override.mstone');

               if Firefox_Box3.Checked then AddFirefoxConfiguration(Configuration, 'extensions.showMismatchUI', 'false')
                                       else DelFirefoxConfiguration(Configuration, 'extensions.showMismatchUI');

               Installe:=Firefox_Installe.Checked;
               ESR:=Firefox_ESR.Checked;
               Modules:=Firefox_Modules.ItemIndex;
          end;
          with Thunderbird do
          begin
               Actif:=FicheUpdateSoft.Thunderbird.Checked;

               if Thunderbird_Box0.Checked then
               begin
                    AddThunderbirdConfiguration(Configuration, 'app.update.auto', 'false');
                    AddThunderbirdConfiguration(Configuration, 'app.update.enabled', 'false');
               end
               else
               begin
                    DelThunderbirdConfiguration(Configuration, 'app.update.auto');
                    DelThunderbirdConfiguration(Configuration, 'app.update.enabled');
               end;

               if Thunderbird_Box1.Checked then
               begin
                    AddThunderbirdConfiguration(Configuration, 'extensions.update.enabled', 'false');
                    AddThunderbirdConfiguration(Configuration, 'extensions.update.autoUpdateDefault', 'false');
               end
               else
               begin
                    DelThunderbirdConfiguration(Configuration, 'extensions.update.enabled');
                    DelThunderbirdConfiguration(Configuration, 'extensions.update.autoUpdateDefault');
               end;

               Installe:=Thunderbird_Installe.Checked;
               // ESR:=Thunderbird_ESR.Checked;
               Modules:=Thunderbird_Modules.ItemIndex;
          end;
          with VLC do
          begin
               Actif:=FicheUpdateSoft.VLC.Checked;
               Update:=VLC_Update.ItemIndex;
               Modules:=VLC_Modules.ItemIndex;
               Installe:=VLC_Installe.Checked;
          end;
          with AIR do
          begin
               Actif:=FicheUpdateSoft.AIR.Checked;
               Update:=AIR_Update.ItemIndex;
               Installe:=AIR_Installe.Checked;
          end;
          with OS do
          begin
               Win_XP:=General_Windows_XP.Checked;
               Win_2003:=General_Windows_2003.Checked;
               Win_Vista:=General_Windows_Vista.Checked;
               Win_7:=General_Windows_7.Checked;
               Win_8:=General_Windows_8.Checked;
               Win_2008:=General_Windows_2008.Checked;
               Win_2012:=General_Windows_2012.Checked;
               Win_10:=General_Windows_10.Checked;
               Win_11:=General_Windows_11.Checked;
          end;
     end;
     FlashPanel.Visible:=General_Mode.ItemIndex<>0;
     JavaPanel.Visible:=General_Mode.ItemIndex<>0;
     VLCPanel.Visible:=General_Mode.ItemIndex<>0;
     AIRPanel.Visible:=General_Mode.ItemIndex<>0;
     Index_EducationPanel.Visible:=General_Mode.ItemIndex<>0;
     General_Box5.Enabled:=General_Mode.ItemIndex<>1;
     General_Box2.Enabled:=General_Box1.Checked;
     General_Proxy1.Enabled:=General_Mode.ItemIndex<>1;
     General_Proxy2.Enabled:=General_Proxy1.Enabled;
     General_Box6.Enabled:=General_Mode.ItemIndex<>0;
     General_Box7.Enabled:=General_Mode.ItemIndex<>0;
     General_UpDown3.Enabled:=General_Mode.ItemIndex<>0;
     General_UpDown4.Enabled:=General_Mode.ItemIndex<>0;
     General_Proxy_Adresse.Enabled:=General_Proxy2.Checked and General_Proxy2.Enabled;
     if General_Proxy_Adresse.Enabled then General_Proxy_Adresse.Color:=$00E9DCA3 else General_Proxy_Adresse.Color:=clSilver;
     Firefox_Panel.Visible:=General_Mode.ItemIndex<>0;
     PageFirefox_General.TabVisible:=General_Mode.ItemIndex<>0;
     PageFirefox_Configuration.TabVisible:=General_Mode.ItemIndex<>0;
     if General_Mode.ItemIndex=0 then Firefox_Classeur.ActivePage:=PageFirefox_Telechargement
     else if Firefox_Classeur.ActivePage=PageFirefox_Telechargement then Firefox_Classeur.ActivePage:=PageFirefox_General;

     Thunderbird_Panel.Visible:=General_Mode.ItemIndex<>0;
     PageThunderbird_General.TabVisible:=General_Mode.ItemIndex<>0;
     PageThunderbird_Configuration.TabVisible:=General_Mode.ItemIndex<>0;
     if General_Mode.ItemIndex=0 then Thunderbird_Classeur.ActivePage:=PageThunderbird_Telechargement
     else if Thunderbird_Classeur.ActivePage=PageThunderbird_Telechargement then Thunderbird_Classeur.ActivePage:=PageThunderbird_General;

     Flash_General.TabVisible:=General_Mode.ItemIndex>0;
     Flash_Exclusions.TabVisible:=General_Mode.ItemIndex>0;
     Java_General.TabVisible:=General_Mode.ItemIndex>0;
     Java_Exclusions.TabVisible:=General_Mode.ItemIndex>0;
     Java_Sites.TabVisible:=General_Mode.ItemIndex>0;
     if not Flash_General.TabVisible then Flash_Classeur.ActivePage:=Flash_General;
     if not Java_General.TabVisible then Java_Classeur.ActivePage:=Java_General;

     Groupe_Proxy.Visible:=General_Proxy1.Enabled and General_Proxy1.Checked;
end;

procedure TFicheUpdateSoft.ConfigurationVersComposants;
var i, Row: integer;
begin
     Tag:=1;
     with Configuration do
     begin
          with General do
          begin
               General_Mode.ItemIndex:=Mode;
               General_Box1.Checked:=Fenetre;
               General_Box2.Checked:=Fenetre_Ouverte;
               General_Box6.Checked:=AfficherMessage;
               General_Box3.Checked:=Log;
               General_Box4.Checked:=Stopper;
               General_Updown2.Position:=Stopper_Minutes;
               General_Box7.Checked:=Stopper_Installation;
               General_Updown4.Position:=Stopper_Installation_Minutes;
               General_Box5.Checked:=UpdateSoft;
               General_Proxy1.Checked:=not Proxy;
               General_Proxy2.Checked:=Proxy;
               General_Proxy_Adresse.Text:=Proxy_Adresse;
          end;
          with Flash do
          begin
               FicheUpdateSoft.Flash.Checked:=Actif;
               Flash_Update.ItemIndex:=Update;
               Flash_Modules.ItemIndex:=Modules;
               Flash_Installe.Checked:=Installe;
               Flash_Exclusions_Nouveau.Text:='';
               Flash_Exclusions_Liste.Clear;
               Flash_Exclusions_Liste.Items.AddStrings(Exclusions);
          end;
          with Index_Education do
          begin
               FicheUpdateSoft.Index_Education.Checked:=Actif;
               Index_Education_Logiciels.ItemIndex:=Logiciels;
               Index_Education_Modules.ItemIndex:=Modules;
               Index_Education_Update.Checked:=Update;
               Index_Education_Dossier_Pronote32.Text:=Dossier_Pronote32;
               Index_Education_Dossier_Pronote64.Text:=Dossier_Pronote64;
               Index_Education_Dossier_EDT32.Text:=Dossier_EDT32;
               Index_Education_Dossier_EDT64.Text:=Dossier_EDT64;
          end;
          with Java do
          begin
               FicheUpdateSoft.Java.Checked:=Actif;
               Java_Update.ItemIndex:=Update;
               Java_Modules.ItemIndex:=Modules;
               Java_Securite.ItemIndex:=Securite;
               Java_Desinstalle.Checked:=Desinstalle;
               Java_Installe.Checked:=Installe;
               Java_Exclusions_Nouveau.Text:='';
               Java_Exclusions_Liste.Clear;
               Java_Exclusions_Liste.Items.AddStrings(Exclusions);
               Java_Sites_0.Checked:=Sites_Autorisation=0;
               Java_Sites_1.Checked:=Sites_Autorisation=1;
               Java_Sites_2.Checked:=Sites_Autorisation=2;
               Java_Sites_Nouveau.Text:='';
               Java_Sites_Liste.Clear;
               Java_Sites_Liste.Items.AddStrings(Sites);
          end;
          with Firefox do
          begin
               FicheUpdateSoft.Firefox.Checked:=Actif;
               Firefox_Configuration.Strings.Clear;
               Firefox_Box0.Checked:=SameText(GetFirefoxConfiguration(Configuration, 'app.update.auto'), 'false') and
                                     SameText(GetFirefoxConfiguration(Configuration, 'app.update.enabled'), 'false');
               Firefox_Box1.Checked:=SameText(GetFirefoxConfiguration(Configuration, 'extensions.update.enabled'), 'false') and
                                     SameText(GetFirefoxConfiguration(Configuration, 'extensions.update.autoUpdateDefault'), 'false');
               Firefox_Box2.Checked:=SameText(GetFirefoxConfiguration(Configuration, 'browser.startup.homepage_override.mstone'), 'ignore');
               Firefox_Box3.Checked:=SameText(GetFirefoxConfiguration(Configuration, 'extensions.showMismatchUI'), 'false');
               for i:=0 to length(Config)-1 do
                   if not Firefox_Configuration.FindRow(Config[i].Key, Row) then Firefox_Configuration.InsertRow(Config[i].Key, Config[i].Value, true);
               Firefox_Installe.Checked:=Installe;
               Firefox_ESR.Checked:=ESR;
               Firefox_Modules.ItemIndex:=Modules;
          end;
          with Thunderbird do
          begin
               FicheUpdateSoft.Thunderbird.Checked:=Actif;
               Thunderbird_Configuration.Strings.Clear;
               Thunderbird_Box0.Checked:=SameText(GetThunderbirdConfiguration(Configuration, 'app.update.auto'), 'false') and
                                     SameText(GetThunderbirdConfiguration(Configuration, 'app.update.enabled'), 'false');
               Thunderbird_Box1.Checked:=SameText(GetThunderbirdConfiguration(Configuration, 'extensions.update.enabled'), 'false') and
                                     SameText(GetThunderbirdConfiguration(Configuration, 'extensions.update.autoUpdateDefault'), 'false');
               for i:=0 to length(Config)-1 do
                   if not Thunderbird_Configuration.FindRow(Config[i].Key, Row) then Thunderbird_Configuration.InsertRow(Config[i].Key, Config[i].Value, true);
               Thunderbird_Installe.Checked:=Installe;
               // Thunderbird_ESR.Checked:=ESR;
               Thunderbird_Modules.ItemIndex:=Modules;
          end;
          with VLC do
          begin
               FicheUpdateSoft.VLC.Checked:=Actif;
               VLC_Update.ItemIndex:=Update;
               VLC_Modules.ItemIndex:=Modules;
               VLC_Installe.Checked:=Installe;
          end;
          with AIR do
          begin
               FicheUpdateSoft.AIR.Checked:=Actif;
               AIR_Update.ItemIndex:=Update;
               AIR_Installe.Checked:=Installe;
          end;
          with OS do
          begin
               General_Windows_XP.Checked:=Win_XP;
               General_Windows_2003.Checked:=Win_2003;
               General_Windows_Vista.Checked:=Win_Vista;
               General_Windows_7.Checked:=Win_7;
               General_Windows_8.Checked:=Win_8;
               General_Windows_2008.Checked:=Win_2008;
               General_Windows_2012.Checked:=Win_2012;
               General_Windows_10.Checked:=Win_10;
               General_Windows_11.Checked:=Win_11;
          end;
          Modifie:=false;
     end;
     Tag:=0;
     ComposantsVersConfiguration; // Permet de valider ce qui vient d'tre affect
end;

procedure DefautConfiguration(var _Configuration: TConfiguration);
var L: TStringList;
    i: integer;
begin
     with _Configuration do
     begin
          with General do
          begin
               Mode:=0;
               Fenetre:=true;
               Fenetre_Ouverte:=true;
               AfficherMessage:=false;
               Log:=true;
               Stopper:=false;
               Stopper_Minutes:=5;
               Stopper_Installation:=true;
               Stopper_Installation_Minutes:=5;
               UpdateSoft:=true;
               Proxy:=false;
               Proxy_Adresse:='';
          end;
          with Flash do
          begin
               Actif:=false;
               Update:=0;
               Modules:=2;
               Installe:=true;
               Exclusions.Clear;
          end;
          with Index_Education do
          begin
               Actif:=false;
               Logiciels:=2;
               Modules:=2;
               Update:=false;
               Dossier_Pronote32:='';
               Dossier_EDT32:='';
               with TRegistry.Create(KEY_READ or $0100) do
               begin
                    RootKey:=HKEY_LOCAL_MACHINE;
                    if OpenKey('\SOFTWARE\Index Education\Locales', false) then
                    begin
                         L:=TStringList.Create;
                         GetValueNames(L);
                         i:=0;
                         while (i<L.Count) and ((Dossier_Pronote32='') or (Dossier_EDT32='')) do
                         begin
                              if FileExists(L[i]) and (Pos('PRONOTE', UpperCase(ExtractFileName(L[i])))>0) then Dossier_Pronote32:=ExtractFilePath(L[0]) else
                              if FileExists(L[i]) and (Pos('EDT', UpperCase(ExtractFileName(L[i])))>0) then Dossier_EDT32:=ExtractFilePath(L[0]);
                              Inc(i);
                         end;
                         L.Free;
                    end;
                    Free;
               end;
               if GetUNCName(Dossier_Pronote32)<>'' then Dossier_Pronote32:=IncludeTrailingPathDelimiter(GetUNCName(Dossier_Pronote32));
               Dossier_Pronote64:=Dossier_Pronote32;
               if GetUNCName(Dossier_EDT32)<>'' then Dossier_EDT32:=IncludeTrailingPathDelimiter(GetUNCName(Dossier_EDT32));
               Dossier_EDT64:=Dossier_EDT32;
          end;
          with Java do
          begin
               Actif:=false;
               Update:=0;
               Modules:=2;
               Securite:=0;
               Desinstalle:=false;
               Installe:=true;
               Exclusions.Clear;
               Sites_Autorisation:=0;
               Sites.Clear;
          end;
          with Firefox do
          begin
               Actif:=false;
               Installe:=true;
               ESR:=false;
               Modules:=0;
               Finalize(Config);
          end;
          with Thunderbird do
          begin
               Actif:=false;
               Installe:=true;
               Modules:=0;
               Finalize(Config);
          end;
          with VLC do
          begin
               Actif:=false;
               Update:=0;
               Modules:=0;
               Installe:=true;
          end;
          with AIR do
          begin
               Actif:=false;
               Update:=0;
               Installe:=true;
          end;
          with OS do
          begin
               Win_XP:=true;
               Win_2003:=true;
               Win_Vista:=true;
               Win_7:=true;
               Win_8:=true;
               Win_2008:=true;
               Win_2012:=true;
               Win_10:=true;
               Win_11:=true;
          end;
          Modifie:=false;
          Fichier:='';
     end;
end;

procedure TFicheUpdateSoft.General_ModeClick(Sender: TObject);
begin
     if Sender=General_Mode then
     begin
          case General_Mode.ItemIndex of
          0: General_Mode_Info.Caption:='Utilisez le mode "Tlchargement des mises  jour" pour tlcharger les mises  jour des composants slectionns, par exemple sur un serveur, lors de l''excution d''une tche planifie.';
          1: General_Mode_Info.Caption:='Utilisez le mode "Installation des mises  jour" pour installer sur les stations excutant UpdateSoft, par exemple par GPO, les composants slectionns prcdemment tlchargs.';
          2: General_Mode_Info.Caption:='Utilisez le mode "Tlchargement puis installation des mises  jour" pour tlcharger puis installer les mises  jour des composants slectionns, par exemple sur un serveur, lors de l''excution d''une tche planifie,'+' afin de garantir la mise  jour permanente de ces composants du serveur.';
          end;
     end;
     if Tag=0 then
     begin
          Configuration.Modifie:=true;
          Caption:=NOMAPPLI+' '+GetVersion+' - ';
          if Configuration.Fichier<>'' then Caption:=Caption+ExtractFileName(Configuration.Fichier)+' ';
          Caption:=Caption+'(Fichier non enregistr)';
          Enregistrer1.Enabled:=true;
          ComposantsVersConfiguration;
     end;
end;

procedure TFicheUpdateSoft.Ouvrir1Click(Sender: TObject);
begin
     Application.ProcessMessages;
     if FermerConfiguration and Ouvrir.Execute then
     begin
          Application.ProcessMessages;
          LireConfiguration(Configuration, Ouvrir.FileName);
          ConfigurationVersComposants;
          Tester.Enabled:=true;
          Enregistrer1.Enabled:=false;
          Configuration.Modifie:=false;
          Caption:=NOMAPPLI+' '+GetVersion+' - '+ExtractFileName(Configuration.Fichier);
     end;
end;

procedure LireConfiguration(var _Configuration: TConfiguration ; FileName: TFileName);
const Exclusion_Tag='Exclusion';
      Site_Tag='Site';
var L: TStringList;
    i: integer;
begin
     DefautConfiguration(Configuration);

     with TInifile.Create(FileName), _Configuration do
     begin
          with General do
          begin
               Mode:=ReadInteger('Gnral', 'Mode', Mode);
               Fenetre:=ReadBool('Gnral', 'Fentre', Fenetre);
               Fenetre_Ouverte:=ReadBool('Gnral', 'Fentre ouverte', Fenetre_Ouverte);
               AfficherMessage:=ReadBool('Gnral', 'Afficher message', AfficherMessage);
               Log:=ReadBool('Gnral', 'Log', Log);
               Stopper:=ReadBool('Gnral', 'Stopper', Stopper);
               Stopper_Minutes:=ReadInteger('Gnral', 'Stopper Minutes', Stopper_Minutes);
               Stopper_Installation:=ReadBool('Gnral', 'Stopper Installation', Stopper_Installation);
               Stopper_Installation_Minutes:=ReadInteger('Gnral', 'Stopper Installation Minutes', Stopper_Installation_Minutes);
               Proxy:=ReadBool('Gnral', 'Proxy', false);
               Proxy_Adresse:=ReadString('Gnral', 'Proxy Adresse', '');
               UpdateSoft:=ReadBool('Gnral', 'UpdateSoft', UpdateSoft);
          end;
          with Flash do
          begin
               Actif:=ReadBool('Flash', 'Actif', Actif);
               Update:=ReadInteger('Flash', 'Update', Update);
               Modules:=ReadInteger('Flash', 'Modules', Modules);
               Installe:=ReadBool('Flash', 'Install', Installe);
               Exclusions.Clear;
               L:=TStringList.Create;
               ReadSectionValues('Flash Exclusions', L);
               for i:=0 to L.Count-1 do
               begin
                    L.Values[L.Names[i]]:=NETBIOS(L.Values[L.Names[i]]);
                    if SameText(Copy(L.Names[i], 1, length(Exclusion_Tag)), Exclusion_Tag) and (L.Values[L.Names[i]]<>'') and (Exclusions.IndexOf(L.Values[L.Names[i]])=-1) then
                         Exclusions.Add(L.Values[L.Names[i]]);
               end;
               L.Free;
          end;
          with Index_Education do
          begin
               Actif:=ReadBool('Index_Education', 'Actif', Actif);
               Logiciels:=ReadInteger('Index_Education', 'Logiciels', Logiciels);
               Modules:=ReadInteger('Index_Education', 'Modules', Modules);
               Update:=ReadBool('Index_Education', 'Update', Update);
               Dossier_Pronote32:=ReadString('Index_Education', 'Dossier_Pronote32', Dossier_Pronote32);
               Dossier_Pronote64:=ReadString('Index_Education', 'Dossier_Pronote64', Dossier_Pronote64);
               Dossier_EDT32:=ReadString('Index_Education', 'Dossier_EDT32', Dossier_EDT32);
               Dossier_EDT64:=ReadString('Index_Education', 'Dossier_EDT64', Dossier_EDT64);
          end;
          with Java do
          begin
               Actif:=ReadBool('Java', 'Actif', Actif);
               Update:=ReadInteger('Java', 'Update', Update);
               Modules:=ReadInteger('Java', 'Modules', Modules);
               Securite:=ReadInteger('Java', 'Scurit', Securite);
               Desinstalle:=ReadBool('Java', 'Dsinstallation', Desinstalle);
               Installe:=ReadBool('Java', 'Install', Installe);
               L:=TStringList.Create;
               ReadSectionValues('Java Exclusions', L);
               for i:=0 to L.Count-1 do
               begin
                    L.Values[L.Names[i]]:=NETBIOS(L.Values[L.Names[i]]);
                    if SameText(Copy(L.Names[i], 1, length(Exclusion_Tag)), Exclusion_Tag) and (L.Values[L.Names[i]]<>'') and (Exclusions.IndexOf(L.Values[L.Names[i]])=-1) then
                         Exclusions.Add(L.Values[L.Names[i]]);
               end;
               Sites_Autorisation:=ReadInteger('Java', 'Sites', Sites_Autorisation);
               L.Clear;
               ReadSectionValues('Java Sites', L);
               for i:=0 to L.Count-1 do
               begin
                    L.Values[L.Names[i]]:=L.Values[L.Names[i]];
                    if SameText(Copy(L.Names[i], 1, length(Site_Tag)), Site_Tag) and (L.Values[L.Names[i]]<>'') and (Sites.IndexOf(L.Values[L.Names[i]])=-1) then
                         Sites.Add(L.Values[L.Names[i]]);
               end;
               L.Free;
          end;
          with Firefox do
          begin
               Actif:=ReadBool('Firefox', 'Actif', Actif);
               Installe:=ReadBool('Firefox', 'Install', Installe);
               ESR:=ReadBool('Firefox', 'ESR', false);
               Modules:=ReadInteger('Firefox', 'Modules', Modules);
               If ValueExists('Firefox', 'Update') then
               begin
                    case ReadInteger('Firefox', 'Update', 0) of
                    1:
                    begin
                         AddFirefoxConfiguration(_Configuration, 'app.update.enabled', 'false');
                         AddFirefoxConfiguration(_Configuration, 'app.update.auto', 'false');
                    end;
                    2:
                    begin
                         AddFirefoxConfiguration(_Configuration, 'app.update.enabled', 'true');
                         AddFirefoxConfiguration(_Configuration, 'app.update.auto', 'true');
                    end;
                    end;
                    if ReadBool('Firefox', 'Extensions', true) then
                    begin
                         AddFirefoxConfiguration(_Configuration, 'extensions.update.enabled', 'false');
                         AddFirefoxConfiguration(_Configuration, 'extensions.update.autoUpdateDefault', 'false');
                    end;
                    if ReadBool('Firefox', 'Bienvenue', true) then AddFirefoxConfiguration(_Configuration, 'browser.startup.homepage_override.mstone', 'ignore');
                    if ReadBool('Firefox', 'Compatibilit', true) then AddFirefoxConfiguration(_Configuration, 'extensions.showMismatchUI', 'false');
               end
               else
               begin
                    L:=TStringList.Create;
                    ReadSectionValues('Firefox_Configuration', L);
                    for i:=0 to L.Count-1 do AddFirefoxConfiguration(_Configuration, L.Names[i], L.Values[L.Names[i]]);
                    L.Free;
               end;
          end;
          with Thunderbird do
          begin
               Actif:=ReadBool('Thunderbird', 'Actif', Actif);
               Installe:=ReadBool('Thunderbird', 'Install', Installe);
               // ESR:=ReadBool('Thunderbird', 'ESR', false);
               Modules:=ReadInteger('Thunderbird', 'Modules', Modules);

               If ValueExists('Thunderbird', 'Update') then
               begin
                    case ReadInteger('Thunderbird', 'Update', 0) of
                    1:
                    begin
                         AddThunderbirdConfiguration(_Configuration, 'app.update.enabled', 'false');
                         AddThunderbirdConfiguration(_Configuration, 'app.update.auto', 'false');
                    end;
                    2:
                    begin
                         AddThunderbirdConfiguration(_Configuration, 'app.update.enabled', 'true');
                         AddThunderbirdConfiguration(_Configuration, 'app.update.auto', 'true');
                    end;
                    end;
                    if ReadBool('Thunderbird', 'Extensions', true) then
                    begin
                         AddThunderbirdConfiguration(_Configuration, 'extensions.update.enabled', 'false');
                         AddThunderbirdConfiguration(_Configuration, 'extensions.update.autoUpdateDefault', 'false');
                    end;
               end
               else
               begin
                    L:=TStringList.Create;
                    ReadSectionValues('Thunderbird_Configuration', L);
                    for i:=0 to L.Count-1 do AddThunderbirdConfiguration(_Configuration, L.Names[i], L.Values[L.Names[i]]);
                    L.Free;
               end;
          end;
          with VLC do
          begin
               Actif:=ReadBool('VLC', 'Actif', Actif);
               Update:=ReadInteger('VLC', 'Update', Update);
               Modules:=ReadInteger('VLC', 'Modules', Modules);
               Installe:=ReadBool('VLC', 'Install', Installe);
          end;
          with AIR do
          begin
               Actif:=ReadBool('AIR', 'Actif', Actif);
               Update:=ReadInteger('AIR', 'Update', Update);
               Installe:=ReadBool('AIR', 'Install', Installe);
          end;
          with OS do
          begin
               Win_XP:=ReadBool('OS', 'Win_XP', Win_XP);
               Win_2003:=ReadBool('OS', 'Win_2003', Win_2003);
               Win_Vista:=ReadBool('OS', 'Win_Vista', Win_Vista);
               Win_7:=ReadBool('OS', 'Win_7', Win_7);
               Win_8:=ReadBool('OS', 'Win_8', Win_8);
               Win_2008:=ReadBool('OS', 'Win_2008', Win_2008);
               Win_2012:=ReadBool('OS', 'Win_2012', Win_2012);
               Win_10:=ReadBool('OS', 'Win_10', Win_10);
               Win_11:=ReadBool('OS', 'Win_11', Win_11);
          end;
          Free;
     end;
     _Configuration.Fichier:=FileName;
end;

function TFicheUpdateSoft.EnregistrerConfigurationSous: bool;
begin
     Application.ProcessMessages;
     if Enregistrer.Execute then
     begin
          Application.ProcessMessages;
          EnregistrerConfiguration(Enregistrer.FileName);
          result:=true;
     end else result:=false;
end;

procedure TFicheUpdateSoft.EnregistrerConfiguration(FileName: TFileName);
const Exclusion_Tag='Exclusion';
      Site_Tag='Site';
var i: integer;
begin
     Configuration.Modifie:=false;
     with TInifile.Create(FileName), Configuration do
     begin
          with General do
          begin
               WriteInteger('Gnral', 'Mode', Mode);
               WriteBool('Gnral', 'Fentre', Fenetre);
               WriteBool('Gnral', 'Fentre ouverte', Fenetre_Ouverte);
               WriteBool('Gnral', 'Afficher message', AfficherMessage);
               WriteBool('Gnral', 'Log', Log);
               WriteBool('Gnral', 'Stopper', Stopper);
               WriteInteger('Gnral', 'Stopper Minutes', Stopper_Minutes);
               WriteBool('Gnral', 'Stopper Installation', Stopper_Installation);
               WriteInteger('Gnral', 'Stopper Installation Minutes', Stopper_Installation_Minutes);
               WriteBool('Gnral', 'Proxy', Proxy);
               WriteString('Gnral', 'Proxy Adresse', Proxy_Adresse);
               WriteBool('Gnral', 'UpdateSoft', UpdateSoft);
          end;
          with Flash do
          begin
               WriteBool('Flash', 'Actif', Actif);
               WriteInteger('Flash', 'Update', Update);
               WriteInteger('Flash', 'Modules', Modules);
               WriteBool('Flash', 'Install', Installe);
               EraseSection('Flash Exclusions');
               for i:=0 to Exclusions.Count-1 do WriteString('Flash Exclusions', Exclusion_Tag+'_'+inttostr(i), Exclusions[i]);
          end;
          with Index_Education do
          begin
               WriteBool('Index_Education', 'Actif', Actif);
               WriteInteger('Index_Education', 'Logiciels', Logiciels);
               WriteInteger('Index_Education', 'Modules', Modules);
               WriteBool('Index_Education', 'Update', Update);
               WriteString('Index_Education', 'Dossier_Pronote32', Dossier_Pronote32);
               WriteString('Index_Education', 'Dossier_Pronote64', Dossier_Pronote64);
               WriteString('Index_Education', 'Dossier_EDT32', Dossier_EDT32);
               WriteString('Index_Education', 'Dossier_EDT64', Dossier_EDT64);
          end;
          with Java do
          begin
               WriteBool('Java', 'Actif', Actif);
               WriteInteger('Java', 'Update', Update);
               WriteInteger('Java', 'Modules', Modules);
               WriteInteger('Java', 'Scurit', Securite);
               WriteBool('Java', 'Dsinstallation', Desinstalle);
               WriteBool('Java', 'Install', Installe);
               EraseSection('Java Exclusions');
               WriteInteger('Java', 'Sites', Sites_Autorisation);
               for i:=0 to Exclusions.Count-1 do WriteString('Java Exclusions', Exclusion_Tag+'_'+inttostr(i), Exclusions[i]);
               EraseSection('Java Sites');
               for i:=0 to Sites.Count-1 do WriteString('Java Sites', Site_Tag+'_'+inttostr(i), Sites[i]);
          end;
          with Firefox do
          begin
               WriteBool('Firefox', 'Actif', Actif);
               DeleteKey('Firefox', 'Update');
               DeleteKey('Firefox', 'Extensions');
               DeleteKey('Firefox', 'Bienvenue');
               DeleteKey('Firefox', 'Compatibilit');
               WriteBool('Firefox', 'Install', Installe);
               WriteBool('Firefox', 'ESR', ESR);
               WriteInteger('Firefox', 'Modules', Modules);
               EraseSection('Firefox_Configuration');
               Firefox_Configuration.Tag:=1;
               Setlength(Config, 0); i:=1;
               with Firefox_Configuration do
               while i<RowCount do
                 if Keys[i]='' then if RowCount>2 then DeleteRow(i) else Inc(i) else begin AddFirefoxConfiguration(Configuration, Keys[i], Values[Keys[i]]); Inc(i); end;
               Firefox_Configuration.Tag:=0;
               for i:=0 to length(Config)-1 do WriteString('Firefox_Configuration', Config[i].Key, Config[i].Value);
          end;
          with Thunderbird do
          begin
               WriteBool('Thunderbird', 'Actif', Actif);
               DeleteKey('Thunderbird', 'Update');
               DeleteKey('Thunderbird', 'Extensions');
               DeleteKey('Thunderbird', 'Bienvenue');
               DeleteKey('Thunderbird', 'Compatibilit');
               WriteBool('Thunderbird', 'Install', Installe);
               // WriteBool('Thunderbird', 'ESR', ESR);
               WriteInteger('Thunderbird', 'Modules', Modules);
               EraseSection('Thunderbird_Configuration');
               Thunderbird_Configuration.Tag:=1;
               Setlength(Config, 0); i:=1;
               with Thunderbird_Configuration do
               while i<RowCount do
                 if Keys[i]='' then if RowCount>2 then DeleteRow(i) else Inc(i) else begin AddThunderbirdConfiguration(Configuration, Keys[i], Values[Keys[i]]); Inc(i); end;
               Thunderbird_Configuration.Tag:=0;
               for i:=0 to length(Config)-1 do WriteString('Thunderbird_Configuration', Config[i].Key, Config[i].Value);
          end;
          with VLC do
          begin
               WriteBool('VLC', 'Actif', Actif);
               WriteInteger('VLC', 'Update', Update);
               WriteInteger('VLC', 'Modules', Modules);
               WriteBool('VLC', 'Install', Installe);
          end;
          with AIR do
          begin
               WriteBool('AIR', 'Actif', Actif);
               WriteInteger('AIR', 'Update', Update);
               WriteBool('AIR', 'Install', Installe);
          end;
          with OS do
          begin
               WriteBool('OS', 'Win_XP', Win_XP);
               WriteBool('OS', 'Win_2003', Win_2003);
               WriteBool('OS', 'Win_Vista', Win_Vista);
               WriteBool('OS', 'Win_7', Win_7);
               WriteBool('OS', 'Win_8', Win_8);
               WriteBool('OS', 'Win_2008', Win_2008);
               WriteBool('OS', 'Win_2012', Win_2012);
               WriteBool('OS', 'Win_10', Win_10);
               WriteBool('OS', 'Win_11', Win_11);
          end;
          Free;
     end;
     Enregistrer1.Enabled:=false;
     Configuration.Fichier:=FileName;
     Tester.Enabled:=true;
     Caption:=NOMAPPLI+' '+GetVersion+' - '+ExtractFileName(Configuration.Fichier);
end;

procedure TFicheUpdateSoft.Enregistrer1Click(Sender: TObject);
begin if Configuration.Fichier<>'' then EnregistrerConfiguration(Configuration.Fichier) else Enregistrersous1Click(nil); end;

procedure TFicheUpdateSoft.Enregistrersous1Click(Sender: TObject);
begin EnregistrerConfigurationSous; end;

procedure TFicheUpdateSoft.Quitter1Click(Sender: TObject);
begin Close; end;

function TFicheUpdateSoft.FermerConfiguration: bool;
begin
     if Configuration.Modifie then
        case MessageDlg(#13+'Souhaitez-vous enregistrer les modifications effectues ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
        mrYes:
        begin
             result:=true;
             if Configuration.Fichier<>'' then Enregistrer1Click(nil) else if not EnregistrerConfigurationSous then result:=false;
        end;
        mrNo: result:=true;
        else result:=false;
        end
     else result:=true;
end;

procedure TFicheUpdateSoft.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     CanClose:=FermerConfiguration;
end;

procedure TFicheUpdateSoft.TesterClick(Sender: TObject);
begin
     if (Configuration.Fichier<>'') and FermerConfiguration then
     begin
          Application.ProcessMessages;
          FicheAttente.ShowModal;
          Application.ProcessMessages;
          MessageDlg(#13+'Test termin.', mtInformation, [mbOK], 0);
     end;
end;

procedure TFicheUpdateSoft.FormCreate(Sender: TObject);
var i: integer; UserName: string;
    ResourceStream: TResourceStream;
    GIFImage: TGIFImage;
begin
     TransfertInstallateursVersSetup;
     Service_Password.PasswordChar:=Chr($0B7);
     Service_Contexte_Compte_Password.PasswordChar:=Chr($0B7);
     if not FileExists(ChangeFileExt(ParamStr(0), '.chm')) then
     try ExtraireRessource(RT_RCDATA, 'HELP', ChangeFileExt(ParamStr(0), '.chm')); except end;
     if not FileExists(ChangeFileExt(ParamStr(0), '.ini')) then
     try ExtraireRessource(RT_RCDATA, 'INI', ChangeFileExt(ParamStr(0), '.ini')); except end;
     Application.HelpFile:=ChangeFileExt(ParamStr(0), '.chm');
     GIFImage := TGIFImage.Create;
     try
        try
           ResourceStream := TResourceStream.Create(hInstance, 'WARNING', RT_RCDATA);
           try
              GIFImage.LoadFromStream(ResourceStream);
           finally
              ResourceStream.Free
           end;
           Groupe_Proxy_Image.Picture.Graphic:=GIFImage;
        finally
           GIFImage.Free
        end;
     except
     end;

     with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
     begin
          PageFlash.Tabvisible:=ReadBool('Options', 'Adobe Flash', true);
          PageJava.Tabvisible:=ReadBool('Options', 'Java', true);
          PageFirefox.Tabvisible:=ReadBool('Options', 'Firefox', true);
          PageThunderbird.Tabvisible:=ReadBool('Options', 'Thunderbird', true);
          PageVLC.Tabvisible:=ReadBool('Options', 'VLC', true);
          PageAIR.Tabvisible:=ReadBool('Options', 'Adobe AIR', true);
          PageIndex_Education.Tabvisible:=ReadBool('Options', 'Index Education', true);
          Free;
     end;
     with Configuration do
     begin
          Flash.Actif:=Flash.Actif and PageFlash.TabVisible;
          Java.Actif:=Java.Actif and PageJava.TabVisible;
          Index_Education.Actif:=Index_Education.Actif and PageIndex_Education.TabVisible;
          Firefox.Actif:=Firefox.Actif and PageFirefox.TabVisible;
          Thunderbird.Actif:=Thunderbird.Actif and PageThunderbird.TabVisible;
          VLC.Actif:=VLC.Actif and PageVLC.TabVisible;
          AIR.Actif:=AIR.Actif and PageAIR.TabVisible;
     end;
     Ouvrir.InitialDir:=ExtractFilePath(ParamStr(0));
     Enregistrer.InitialDir:=ExtractFilePath(ParamStr(0));
     Application.Title:=NOMAPPLI+' '+GetVersion;
     Caption:=Application.Title;
     ConfigurationVersComposants;
     ClasseurSecondaire.ActivePage:=PageFonctionnement;
     ClasseurService.ActivePage:=PageServicePartage;
     Classeur3.ActivePageIndex:=0;
     Classeur.ActivePage:=PageGeneral;
     Flash_Classeur.ActivePage:=Flash_General;
     Java_Classeur.ActivePage:=Java_General;
     HorlogeMAJ.Enabled:=true;
     Tag:=1;
     General_ModeClick(General_Mode);
     Tag:=0;
     if IsServiceInstalled(true, UserName) then
     begin
          if UserName<>'' then begin Service_Contexte_Compte_Nom.Text:=UserName; Service_Contexte_Compte.Checked:=true; Service_Contexte_Compte_Password.Text:='********'; end;
          with TRegistry.Create do
          try
             Rootkey:=HKEY_LOCAL_MACHINE;
             if OpenKey(SERVICE_CONFIGURATION_KEY, false) then
             begin Service_Chemin.Text:=ExtractFilePath(ReadString('Folder')); Service_Script.Text:=ReadString('Script'); Service_Nom.Text:=ReadString('User'); if Service_Nom.Text<>'' then Service_Password.Text:='********'; end;
          finally
             Free;
          end;
     end
     else Service_Chemin.Text:=GetFullPath(ExtractFilePath(ParamStr(0)));
     Service_Programmation_Actif.Tag:=1;
     Service_Programmation_Actif.Checked:=IsServiceInstalled(true) and TaskExists(NOMAPPLI);
     if Service_Programmation_Actif.Checked then Service_Programmation_Heure.Time:=GetTaskNextTime(NOMAPPLI);
     Service_Programmation_Actif.Tag:=0;
     ActualiserComposantsService;

     DoubleBuffered:=true;
          for i:=0 to ComponentCount-1 do
     begin
          if (Components[i] is TPanel) then
          begin
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).ParentBackground := TRUE;
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).DoubleBuffered:=true;
          end
          else
          if Components[i] is TPageControl then
          begin
               TPageControl(Components[i]).OwnerDraw:=true;
               TPageControl(Components[i]).OnDrawTab:=ClasseurDrawTab;
          end
          else
          if Components[i] is TMenuItem then TMenuItem(Components[i]).OnAdvancedDrawItem:=MenuItemAdvancedDrawItem
          else
          if Components[i] is TColorButton then with TColorButton(Components[i]) do begin DoubleBuffered:=true; HoverColor:=Color; BackColor:=Color; end
          else
          if Components[i] is TEdit then TEdit(Components[i]).Font.Color:=clBlue
          else
          if Components[i] is TListBox then
          begin
               TListBox(Components[i]).Font.Color:=clBlue;
               if not Assigned(TListBox(Components[i]).OnMouseMove) then TListBox(Components[i]).OnMouseMove:=Java_Sites_ListeMouseMove;
          end
          else
          if Components[i] is TWinControl then TWinControl(Components[i]).DoubleBuffered:=true;
          if (Components[i] is TLabel) and TLabel(Components[i]).WordWrap then
             TLabel(Components[i]).Caption:=StringReplace(TLabel(Components[i]).Caption, '. ', '. '#13, [rfReplaceAll]);

          if Components[i] is TRadioButton then AjusterRadioButton(TRadioButton(Components[i]));
          if Components[i] is TCheckBox then AjusterCheckBox(TCheckBox(Components[i]));
     end;
end;

procedure TFicheUpdateSoft.N1Click(Sender: TObject);
begin FicheAPropos.ShowModal; end;

procedure TFicheUpdateSoft.General_Updown2Click(Sender: TObject; Button: TUDBtnType);
begin General_ModeClick(nil); end;

procedure TFicheUpdateSoft.NouveauClick(Sender: TObject);
begin
     if FermerConfiguration then
     begin
          DefautConfiguration(Configuration);
          with Configuration do
          begin
               Flash.Actif:=Flash.Actif and PageFlash.TabVisible;
               Index_Education.Actif:=Index_Education.Actif and PageIndex_Education.TabVisible;
               Java.Actif:=Java.Actif and PageJava.TabVisible;
               Firefox.Actif:=Firefox.Actif and PageFirefox.TabVisible;
               Thunderbird.Actif:=Thunderbird.Actif and PageThunderbird.TabVisible;
               VLC.Actif:=VLC.Actif and PageVLC.TabVisible;
               AIR.Actif:=AIR.Actif and PageAIR.TabVisible;
          end;
          ConfigurationVersComposants;
          Configuration.Modifie:=false;
          Tester.Enabled:=false;
          Caption:=NOMAPPLI+' '+GetVersion;
     end;
end;

procedure TFicheUpdateSoft.FormDestroy(Sender: TObject);
begin HorlogeMAJ.Enabled:=false; DestructionThread(MAJThread); end;

procedure TFicheUpdateSoft.HorlogeMAJTimer(Sender: TObject);
begin
     if HorlogeMAJ.Tag=0 then
     begin
          HorlogeMAJ.Enabled:=false;
          MAJThread:=TMAJThread.Create(true);
          MAJThread.FreeOnTerminate:=false;
          MAJThread.Resume;
     end
     else
     begin
          Misejourdisponible.Visible:=true;
          HorlogeMAJ.Enabled:=false;
     end;
end;

procedure TMAJThread.Execute;
var MAJ: bool;
    Version: string;
begin
     GetUpdateSoftMAJInfos(MAJ, Version, URLDownloadNewVersion);
     if MAJ then Synchronize(FinThread);
end;

procedure TMAJThread.FinThread;
begin
     if Assigned(FicheUpdateSoft) then
     with FicheUpdateSoft do
     begin
          HorlogeMAJ.Tag:=1;
          HorlogeMAJTimer(nil);
     end;
end;

procedure TFicheUpdateSoft.MisejourdisponibleClick(Sender: TObject);
begin
     if URLDownloadNewVersion<>'' then ShellExecute(0, 'open', PChar(URLDownloadNewVersion), nil, nil, SW_SHOWNORMAL);
end;

procedure TFicheUpdateSoft.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin if (Key=VK_F1) and (FileExists(Application.HelpFile)) then ShellExecute(Handle, 'open', PChar(Application.HelpFile), nil, nil, SW_SHOWNORMAL); end;

procedure TFicheUpdateSoft.Firefox_ConfigurationKeyPress(Sender: TObject; var Key: Char);
begin
     if ((Key='=') or (Key=Chr(34))) and (Firefox_Configuration.Col=0) then Key:=#0
     else
     if Key=#13 then
     begin
          if Firefox_Configuration.Col=0 then Firefox_Configuration.Col:=1
          else
          if Firefox_Configuration.Row<Firefox_Configuration.RowCount-1 then
          begin
               Firefox_Configuration.Row:=Firefox_Configuration.Row+1;
               Firefox_Configuration.Col:=0;
          end
          else Firefox_ConfigurationValidate(Sender, Firefox_Configuration.Col, Firefox_Configuration.Row, Firefox_Configuration.GetCell(0, Firefox_Configuration.Row), Firefox_Configuration.GetCell(1, Firefox_Configuration.Row))
     end;
end;

procedure TFicheUpdateSoft.Firefox_ConfigurationValidate(Sender: TObject; ACol, ARow: Integer; const KeyName, KeyValue: String);
var Bon, Trouve: bool;
    i, TheRow, TheRow2: integer;
begin
     Trouve:=false;
     if ACol=0 then
     begin
          if Trim(KeyName)='' then Firefox_Configuration.Cells[1, ARow]:=''
          else
          if not SameText(Trim(KeyName), Firefox_Configuration.TempValue) then
          begin
               i:=1;
               while (i<=Firefox_Configuration.RowCount-1) and not Trouve do
               begin
                    if (i<>ARow) and SameText(Trim(KeyName), Trim(Firefox_Configuration.GetCell(0, i))) then Trouve:=true else Inc(i);
               end;
               if Trouve then
               begin
                    MessageDlg(#13+'La cl "'+KeyName+'" est dj dfinie.', mtWarning, [mbOK], 0);
                    Firefox_Configuration.Cells[ACol, ARow]:=Firefox_Configuration.TempValue;
               end;
          end;
     end;

     with Firefox_Configuration do
     begin
          if SameText(Keys[ARow], 'app.update.enabled') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('app.update.auto', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                     else InsertRow('app.update.auto', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'app.update.auto') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('app.update.enabled', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                        else InsertRow('app.update.enabled', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'extensions.update.autoUpdateDefault') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('extensions.update.enabled', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                               else InsertRow('extensions.update.enabled', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'extensions.update.enabled') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('extensions.update.autoUpdateDefault', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                                         else InsertRow('extensions.update.autoUpdateDefault', Values[Keys[ARow]], true);
          end;

          if FindRow('app.update.auto', TheRow)<>FindRow('app.update.enabled', TheRow2) then
          begin
               if TheRow<0 then InsertRow('app.update.auto', Values[Keys[TheRow2]], true)
                           else InsertRow('app.update.enabled', Values[Keys[TheRow]], true);
          end;

          if FindRow('extensions.update.enabled', TheRow)<>FindRow('extensions.update.autoUpdateDefault', TheRow2) then
          begin
               if TheRow<0 then InsertRow('extensions.update.enabled', Values[Keys[TheRow2]], true)
                           else InsertRow('extensions.update.autoUpdateDefault', Values[Keys[TheRow]], true);
          end;

          Bon:=false;
          if FindRow('app.update.enabled', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'false') and FindRow('app.update.auto', TheRow);
          if Bon then Bon:=SameText(Trim(Cells[1, TheRow]), 'false');
          if Firefox_Box0.Checked<>Bon then begin Tag:=1; Firefox_Box0.Checked:=Bon; Tag:=0; end;

          Bon:=false;
          if FindRow('extensions.update.autoUpdateDefault', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'false') and FindRow('extensions.update.enabled', TheRow);
          if Bon then Bon:=SameText(Trim(Cells[1, TheRow]), 'false');
          if Firefox_Box1.Checked<>Bon then begin Tag:=1; Firefox_Box1.Checked:=Bon; Tag:=0; end;

          Bon:=false;
          if FindRow('browser.startup.homepage_override.mstone', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'ignore');
          if Firefox_Box2.Checked<>Bon then begin Tag:=1; Firefox_Box2.Checked:=Bon; Tag:=0; end;

          Bon:=false;
          if FindRow('extensions.showMismatchUI', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'false');
          if Firefox_Box3.Checked<>Bon then begin Tag:=1; Firefox_Box3.Checked:=Bon; Tag:=0; end;
     end;
     if not Trouve and (ACol=1) and (Trim(KeyName)<>'') and (Trim(KeyValue)<>'') and (ARow=Firefox_Configuration.RowCount-1) then
     begin
          Firefox_Configuration.InsertRow('', '', true);
          Firefox_Configuration.Col:=0;
          Firefox_Configuration.Row:=Firefox_Configuration.Row+1;
     end;
end;

procedure TValueListEditor.DoOnValidate;
begin if goEditing in Options then inherited DoOnValidate; end;

procedure TFicheUpdateSoft.Firefox_ConfigurationStringsChange(Sender: TObject);
begin if Firefox_Configuration.Tag=0 then General_ModeClick(nil); end;

procedure TFicheUpdateSoft.Firefox_ConfigurationGetEditText(Sender: TObject; ACol, ARow: Integer; var Value: String);
begin Firefox_Configuration.TempValue:=Trim(Value); end;

procedure TFicheUpdateSoft.Firefox_BoxClick(State: bool; Key, Value: string ; const FollowClick: bool=true ; const DeleteIfNotExists: bool=true);
var Row: integer;
begin
     if State then
     begin
          if Firefox_Configuration.FindRow(Key, Row) then Firefox_Configuration.Cells[1, Row]:=Value
                                                     else Firefox_Configuration.InsertRow(Key, Value, true);
     end
     else if DeleteIfNotExists and Firefox_Configuration.FindRow(Key, Row) then Firefox_Configuration.DeleteRow(Row);
     if FollowClick then General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Thunderbird_BoxClick(State: bool; Key, Value: string ; const FollowClick: bool=true ; const DeleteIfNotExists: bool=true);
var Row: integer;
begin
     if State then
     begin
          if Thunderbird_Configuration.FindRow(Key, Row) then Thunderbird_Configuration.Cells[1, Row]:=Value
                                                         else Thunderbird_Configuration.InsertRow(Key, Value, true);
     end
     else if DeleteIfNotExists and Thunderbird_Configuration.FindRow(Key, Row) then Thunderbird_Configuration.DeleteRow(Row);
     if FollowClick then General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Firefox_Box0Click(Sender: TObject);
begin
     if Firefox_Configuration.Tag=0 then
     begin
          Firefox_BoxClick(Firefox_Box0.Checked, 'app.update.auto', 'false', false);
          Firefox_BoxClick(Firefox_Box0.Checked, 'app.update.enabled', 'false');
     end;
end;

procedure TFicheUpdateSoft.Firefox_Box1Click(Sender: TObject);
begin
     if Firefox_Configuration.Tag=0 then
     begin
          Firefox_BoxClick(Firefox_Box1.Checked, 'extensions.update.autoUpdateDefault', 'false', false);
          Firefox_BoxClick(Firefox_Box1.Checked, 'extensions.update.enabled', 'false');
     end;
end;

procedure TFicheUpdateSoft.Firefox_Box2Click(Sender: TObject);
begin
     if Firefox_Configuration.Tag=0 then
     Firefox_BoxClick(Firefox_Box2.Checked, 'browser.startup.homepage_override.mstone', 'ignore');
end;

procedure TFicheUpdateSoft.Firefox_Box3Click(Sender: TObject);
begin if Firefox_Configuration.Tag=0 then Firefox_BoxClick(Firefox_Box3.Checked, 'extensions.showMismatchUI', 'false'); end;

procedure TFicheUpdateSoft.PageFirefox_ConfigurationShow(Sender: TObject);
begin
     Firefox_Configuration.Enabled:=false;
     Firefox_Configuration.Options:=Firefox_Configuration.Options-[goEditing];
     Firefox_Configuration.Enabled:=true;
     Firefox_Configuration.Col:=0;
end;

procedure TFicheUpdateSoft.Firefox_ConfigurationEnter(Sender: TObject);
begin Firefox_Configuration.Options:=Firefox_Configuration.Options+[goEditing]; end;

procedure TFicheUpdateSoft.Thunderbird_Modules2Click(Sender: TObject);
begin
     Thunderbird_Modules.ItemIndex:=Thunderbird_Modules2.ItemIndex;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Thunderbird_ModulesClick(Sender: TObject);
begin
     Thunderbird_Modules2.ItemIndex:=Thunderbird_Modules.ItemIndex;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Firefox_Modules2Click(Sender: TObject);
begin
     Firefox_Modules.ItemIndex:=Firefox_Modules2.ItemIndex;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Firefox_ModulesClick(Sender: TObject);
begin
     Firefox_Modules2.ItemIndex:=Firefox_Modules.ItemIndex;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Firefox_ESR2Click(Sender: TObject);
begin
     Firefox_ESR.Checked:=Firefox_ESR2.Checked;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Firefox_ESRClick(Sender: TObject);
begin
     Firefox_ESR2.Checked:=Firefox_ESR.Checked;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Flash_Exclusions_NouveauChange(Sender: TObject);
var i: integer;
begin
     with TEdit(Sender) do
     begin
          if (Sender<>Java_Sites_Nouveau) and (NetBios(Text)<>Text) then
          begin
               i:=SelStart;
               Text:=NetBios(Text);
               SelStart:=i;
          end;
          if Sender=Flash_Exclusions_Nouveau then Flash_Exclusions_Ajouter.Enabled:=(Text<>'') and (Flash_Exclusions_Liste.Items.IndexOf(Text)=-1) else
          if Sender=Java_Exclusions_Nouveau then Java_Exclusions_Ajouter.Enabled:=(Text<>'') and (Java_Exclusions_Liste.Items.IndexOf(Text)=-1) else
          if Sender=Java_Sites_Nouveau then Java_Sites_Ajouter.Enabled:=(Text<>'') and (Java_Sites_Liste.Items.IndexOf(Text)=-1) else
     end;
end;

procedure TFicheUpdateSoft.Flash_Exclusions_NouveauKeyPress(Sender: TObject; var Key: Char);
begin
     if Key=#13 then
     begin
          Key:=#0;
          if Sender=Flash_Exclusions_Nouveau then if Flash_Exclusions_Ajouter.Enabled then Flash_Exclusions_Ajouter.Click else else
          if Sender=Java_Exclusions_Nouveau then if Java_Exclusions_Ajouter.Enabled then Java_Exclusions_Ajouter.Click else else
          if Sender=Java_Sites_Nouveau then if Java_Sites_Ajouter.Enabled then Java_Sites_Ajouter.Click else else
     end;
end;

procedure TFicheUpdateSoft.Flash_Exclusions_AjouterClick(Sender: TObject);
begin
     if Sender=Flash_Exclusions_Ajouter then
     begin
          Flash_Exclusions_Liste.Items.Add(Flash_Exclusions_Nouveau.Text);
          Flash_Exclusions_NouveauChange(Flash_Exclusions_Nouveau);
     end
     else
     if Sender=Java_Exclusions_Ajouter then
     begin
          Java_Exclusions_Liste.Items.Add(Java_Exclusions_Nouveau.Text);
          Flash_Exclusions_NouveauChange(Java_Exclusions_Nouveau);
     end
     else
     if Sender=Java_Sites_Ajouter then
     begin
          Java_Sites_Liste.Items.Add(Java_Sites_Nouveau.Text);
          Flash_Exclusions_NouveauChange(Java_Sites_Nouveau);
     end;
     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Flash_Exclusions_ListeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var i: integer;
    Modifie: bool;
begin
     if Key=VK_DELETE then
     begin
          Modifie:=false; i:=0; while i<TListBox(Sender).Count do if TListBox(Sender).Selected[i] then begin Modifie:=true; TListBox(Sender).Items.Delete(i); end else Inc(i);
          if Sender=Flash_Exclusions_Liste then Flash_Exclusions_NouveauChange(Flash_Exclusions_Nouveau) else
          if Sender=Java_Exclusions_Liste then Flash_Exclusions_NouveauChange(Java_Exclusions_Nouveau) else
          if Sender=Java_Sites_Liste then Flash_Exclusions_NouveauChange(Java_Sites_Nouveau);
          if Modifie then General_ModeClick(nil);
     end;
end;

procedure TFicheUpdateSoft.ClasseurDrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var AText: string;
    APoint: TPoint;
    i, Index: integer;
    Rect2: TRect;
begin
  with (Control as TPageControl).Canvas do
  begin
    Brush.Color := Color;
    Rect2:=Rect;
    FillRect(Rect2);

    Index:=-1;
    for i:=0 to TabIndex do
    repeat
          Inc(Index);
    until (Index>=TPageControl(Control).PageCount) or (TPageControl(Control).Pages[Index].TabVisible);

    if Index<TPageControl(Control).PageCount then
    begin
         AText := TPageControl(Control).Pages[Index].Caption;
         with Control.Canvas do
         begin
              Brush.Style:=bsClear;
              APoint.x := (Rect2.Right - Rect.Left - TextWidth(AText)) div 2;
              APoint.y := (Rect2.Bottom - Rect.Top - TextHeight(AText)) div 2;
              TextRect(Rect2, Rect2.Left + APoint.x+2, Rect2.Top + APoint.y, AText);
         end;
    end;
  end;
end;

type TMyMenuItem = class(TMenuItem);

procedure TFicheUpdateSoft.MenuItemAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; State: TOwnerDrawState);
var OldAdvancedDrawItem: TAdvancedMenuDrawItemEvent;
    i, MaxIndex: integer;
begin
     with ACanvas do
     begin
          MaxIndex:=-1; i:=MainMenu1.Items.Count-1;
          while (MaxIndex=-1) and (i>=0) do if MainMenu1.Items[i].Visible then MaxIndex:=i else Dec(i);
          Brush.Color := Self.Color;
          OldAdvancedDrawItem := TMenuItem(Sender).OnAdvancedDrawItem;
          if (Parent = nil) and (TMenuItem(Sender).MenuIndex = MaxIndex) and not (odHotLight in State) and not (odSelected in State) then
          begin
               ARect.Right := Width;
               FillRect(ARect);
          end;
          try
             TMenuItem(Sender).OnAdvancedDrawItem := nil;
             TMyMenuItem(Sender).AdvancedDrawItem(ACanvas, ARect, State, false);
          finally
             TMenuItem(Sender).OnAdvancedDrawItem := OldAdvancedDrawItem;
          end;
     end;
end;

procedure TFicheUpdateSoft.Thunderbird_Box0Click(Sender: TObject);
begin
     if Thunderbird_Configuration.Tag=0 then
     begin
          Thunderbird_BoxClick(Thunderbird_Box0.Checked, 'app.update.auto', 'false', false);
          Thunderbird_BoxClick(Thunderbird_Box0.Checked, 'app.update.enabled', 'false');
     end;
end;

procedure TFicheUpdateSoft.Thunderbird_Box1Click(Sender: TObject);
begin
     if Thunderbird_Configuration.Tag=0 then
     begin
          Thunderbird_BoxClick(Thunderbird_Box1.Checked, 'extensions.update.autoUpdateDefault', 'false', false);
          Thunderbird_BoxClick(Thunderbird_Box1.Checked, 'extensions.update.enabled', 'false');
     end;
end;

procedure TFicheUpdateSoft.Thunderbird_ESRClick(Sender: TObject);
begin
//     Thunderbird_ESR2.Checked:=Thunderbird_ESR.Checked;
//     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Thunderbird_ConfigurationStringsChange(Sender: TObject);
begin if Thunderbird_Configuration.Tag=0 then General_ModeClick(nil); end;

procedure TFicheUpdateSoft.Thunderbird_ConfigurationKeyPress(Sender: TObject; var Key: Char);
begin
     if ((Key='=') or (Key=Chr(34))) and (Thunderbird_Configuration.Col=0) then Key:=#0
     else
     if Key=#13 then
     begin
          if Thunderbird_Configuration.Col=0 then Thunderbird_Configuration.Col:=1
          else
          if Thunderbird_Configuration.Row<Thunderbird_Configuration.RowCount-1 then
          begin
               Thunderbird_Configuration.Row:=Thunderbird_Configuration.Row+1;
               Thunderbird_Configuration.Col:=0;
          end
          else Thunderbird_ConfigurationValidate(Sender, Thunderbird_Configuration.Col, Thunderbird_Configuration.Row, Thunderbird_Configuration.GetCell(0, Thunderbird_Configuration.Row), Thunderbird_Configuration.GetCell(1, Thunderbird_Configuration.Row))
     end;
end;

procedure TFicheUpdateSoft.Thunderbird_ConfigurationGetEditText(Sender: TObject; ACol, ARow: Integer; var Value: String);
begin Thunderbird_Configuration.TempValue:=Trim(Value); end;

procedure TFicheUpdateSoft.Thunderbird_ConfigurationEnter(Sender: TObject);
begin Thunderbird_Configuration.Options:=Thunderbird_Configuration.Options+[goEditing]; end;

procedure TFicheUpdateSoft.Thunderbird_ConfigurationValidate(Sender: TObject; ACol, ARow: Integer; const KeyName, KeyValue: String);
var Bon, Trouve: bool;
    i, TheRow, TheRow2: integer;
begin
     Trouve:=false;
     if ACol=0 then
     begin
          if Trim(KeyName)='' then Thunderbird_Configuration.Cells[1, ARow]:=''
          else
          if not SameText(Trim(KeyName), Thunderbird_Configuration.TempValue) then
          begin
               i:=1;
               while (i<=Thunderbird_Configuration.RowCount-1) and not Trouve do
               begin
                    if (i<>ARow) and SameText(Trim(KeyName), Trim(Thunderbird_Configuration.GetCell(0, i))) then Trouve:=true else Inc(i);
               end;
               if Trouve then
               begin
                    MessageDlg(#13+'La cl "'+KeyName+'" est dj dfinie.', mtWarning, [mbOK], 0);
                    Thunderbird_Configuration.Cells[ACol, ARow]:=Thunderbird_Configuration.TempValue;
               end;
          end;
     end;

     with Thunderbird_Configuration do
     begin
          if SameText(Keys[ARow], 'app.update.enabled') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('app.update.auto', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                     else InsertRow('app.update.auto', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'app.update.auto') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('app.update.enabled', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                        else InsertRow('app.update.enabled', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'extensions.update.autoUpdateDefault') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('extensions.update.enabled', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                               else InsertRow('extensions.update.enabled', Values[Keys[ARow]], true);
          end;

          if SameText(Keys[ARow], 'extensions.update.enabled') then
          begin
               if not SameText(Values[Keys[ARow]], 'false') and not SameText(Values[Keys[ARow]], 'true') then Values[Keys[ARow]]:='false';
               if FindRow('extensions.update.autoUpdateDefault', TheRow) then Values[Keys[TheRow]]:=Values[Keys[ARow]]
                                                                         else InsertRow('extensions.update.autoUpdateDefault', Values[Keys[ARow]], true);
          end;

          if FindRow('app.update.auto', TheRow)<>FindRow('app.update.enabled', TheRow2) then
          begin
               if TheRow<0 then InsertRow('app.update.auto', Values[Keys[TheRow2]], true)
                           else InsertRow('app.update.enabled', Values[Keys[TheRow]], true);
          end;

          if FindRow('extensions.update.enabled', TheRow)<>FindRow('extensions.update.autoUpdateDefault', TheRow2) then
          begin
               if TheRow<0 then InsertRow('extensions.update.enabled', Values[Keys[TheRow2]], true)
                           else InsertRow('extensions.update.autoUpdateDefault', Values[Keys[TheRow]], true);
          end;

          Bon:=false;
          if FindRow('app.update.enabled', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'false') and FindRow('app.update.auto', TheRow);
          if Bon then Bon:=SameText(Trim(Cells[1, TheRow]), 'false');
          if Thunderbird_Box0.Checked<>Bon then begin Tag:=1; Thunderbird_Box0.Checked:=Bon; Tag:=0; end;

          Bon:=false;
          if FindRow('extensions.update.autoUpdateDefault', TheRow) then Bon:=SameText(Trim(Cells[1, TheRow]), 'false') and FindRow('extensions.update.enabled', TheRow);
          if Bon then Bon:=SameText(Trim(Cells[1, TheRow]), 'false');
          if Thunderbird_Box1.Checked<>Bon then begin Tag:=1; Thunderbird_Box1.Checked:=Bon; Tag:=0; end;
     end;
     if not Trouve and (ACol=1) and (Trim(KeyName)<>'') and (Trim(KeyValue)<>'') and (ARow=Thunderbird_Configuration.RowCount-1) then
     begin
          Thunderbird_Configuration.InsertRow('', '', true);
          Thunderbird_Configuration.Col:=0;
          Thunderbird_Configuration.Row:=Thunderbird_Configuration.Row+1;
     end;
end;

procedure TFicheUpdateSoft.PageThunderbird_ConfigurationShow(Sender: TObject);
begin
     Thunderbird_Configuration.Enabled:=false;
     Thunderbird_Configuration.Options:=Thunderbird_Configuration.Options-[goEditing];
     Thunderbird_Configuration.Enabled:=true;
     Thunderbird_Configuration.Col:=0;
end;

procedure TFicheUpdateSoft.Thunderbird_ESR2Click(Sender: TObject);
begin
//     Thunderbird_ESR.Checked:=Thunderbird_ESR2.Checked;
//     General_ModeClick(nil);
end;

procedure TFicheUpdateSoft.Java_Sites_ListeMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var k: integer;
    s: string;
begin
     k := (Sender as TListBox).ItemAtPos(Point(X,Y),true);
     if k = -1 then (Sender as TListBox).ShowHint:=false
     else
     begin
          s := (Sender as TListBox).Items[k];
          if (Sender as TListBox).Canvas.TextWidth(s)>(Sender as TListBox).ClientWidth then
          begin
               (Sender as TListBox).ShowHint := true;
               (Sender as TListBox).Hint := (Sender as TListBox).Items[k];
          end
          else
          (Sender as TListBox).ShowHint := false;
     end;
end;

procedure TFicheUpdateSoft.Java_Sites_ListeClick(Sender: TObject);
begin if Java_Sites_Liste.ItemIndex<>-1 then Java_Sites_Nouveau.Text:=Java_Sites_Liste.Items[Java_Sites_Liste.ItemIndex]; end;

procedure TFicheUpdateSoft.Java_Exclusions_ListeClick(Sender: TObject);
begin if Java_Exclusions_Liste.ItemIndex<>-1 then Java_Exclusions_Nouveau.Text:=Java_Exclusions_Liste.Items[Java_Exclusions_Liste.ItemIndex]; end;

procedure TFicheUpdateSoft.Flash_Exclusions_ListeClick(Sender: TObject);
begin if Flash_Exclusions_Liste.ItemIndex<>-1 then Flash_Exclusions_Nouveau.Text:=Flash_Exclusions_Liste.Items[Flash_Exclusions_Liste.ItemIndex]; end;

procedure TFicheUpdateSoft.Service_Chemin_SelectionClick(Sender: TObject);
begin
     Service_Ouvrir.FileName:='';
     Service_Ouvrir.Filter:='Excuteble UpdateSoft.exe|UpdateSoft.exe';
     if Service_Ouvrir.Execute then Service_Chemin.Text:=GetFullPath(ExtractFilePath(Service_Ouvrir.FileName));
end;

procedure TFicheUpdateSoft.Service_Script_SelectionClick(Sender: TObject);
begin
     Service_Ouvrir.FileName:='';
     Service_Ouvrir.Filter:='Scripts UpdateSoft (*.usf)|*.usf|Tous les fichiers (*.*)|*.*';
     if Service_Ouvrir.Execute then  Service_Script.Text:=GetFullPath(Service_Ouvrir.FileName);
end;

function PolicyOK: bool;
const KEY='\SYSTEM\CurrentControlSet\Control\Lsa';
      VALUE='disabledomaincreds';
var reponse: Word;
begin
     result:=false;
     with TRegistry.Create do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey(KEY, false) then
          begin
               result:=ValueExists(VALUE) and not ReadBool(VALUE);
               if not result then
               begin
                    reponse:=MessageDlg('L''option d''accs rseausuivante est active et doit tre dsactive :'#13+#13+'"Ne pas autoriser le stockage de mots de passe et dinformations didentification pour lauthentification du rseau."'+#13+#13+'Dsactiver l''option (redmarrage requis) ?', mtConfirmation, [mbYes, mbCancel], 0);
                    if reponse=mrYes then
                    begin
                         WriteBool(VALUE, false);
                         MessageDlg(#13+'Vous devez redmarrer l''ordinateur pour que les changements prennent effet.', mtInformation, [mbOK], 0);
                    end;
               end;
               CloseKey;
          end;
          Free;
     end;
end;

procedure TFicheUpdateSoft.Service_TesterClick(Sender: TObject);
var Parametre, Chaine: string;
begin
     if ((Sender=Service_Tester) or (Sender=Service_Installer)) and not PolicyOK then exit;

     ActualiserComposantsService(true);
     Application.ProcessMessages;
     with TRegistry.Create(KEY_READ or KEY_WRITE) do
     try
        RootKey := HKEY_LOCAL_MACHINE;
        if OpenKey(ExtractFilePath(SERVICE_APPLICATION_KEY), false) then DeleteKey(NOMAPPLI);
     finally
        Free;
     end;
     if Sender=Service_Tester then Parametre:=PARAM_SERVICE_TEST else
     if Sender=Service_Installer then Parametre:=PARAM_SERVICE_INSTALL else Parametre:=PARAM_SERVICE_UNINSTALL;
     LanceAppliAttenteFin(AnsiQuotedStr(ParamStr(0), '"')+' '+Parametre+' '+AnsiQuotedStr(Service_Chemin.Text, '"')+' '+AnsiQuotedStr(Service_Script.Text, '"')+' '+AnsiQuotedStr(Service_Nom.Text, '"')+' '+AnsiQuotedStr(Service_Password.Text, '"')+' '+PARAM_SERVICE_CONTEXT+' '+Trim(AnsiQuotedStr(Service_Contexte_Compte_Nom.Text, '"')+' '+AnsiQuotedStr(Service_Contexte_Compte_Password.Text, '"')), ExtractFilePath(ParamStr(0)));
     ActualiserComposantsService;
     if Parametre=PARAM_SERVICE_UNINSTALL then Service_Password.Text:='';
     if Parametre=PARAM_SERVICE_INSTALL then
          if IsServiceInstalled(true) then MessageDlg('Le service '+NOMAPPLI+' a t bien install.'+#13+#13+'Ses activits seront consignes dans l''observateur d''vnements Windows.', mtInformation, [mbOK], 0)
                                      else MessageDlg(#13+'Le service '+NOMAPPLI+' n''a pas pu tre install.', mtError, [mbOK], 0);
     if Parametre=PARAM_SERVICE_TEST then
     with TRegistry.Create(KEY_READ or KEY_WRITE) do
     try
        RootKey := HKEY_LOCAL_MACHINE;
        if OpenKey(SERVICE_APPLICATION_KEY, false) then
        begin
             if ReadString('')='OK' then MessageDlg(#13+'Le test a russi : les fichiers sont accessibles.', mtInformation, [mbOK], 0)
                                    else begin Chaine:=ReadString(''); if Pos(#13, Chaine)=0 then Chaine:=#13+Chaine; MessageDlg(Chaine, mtError, [mbOK], 0); end;
             CloseKey;
        end else MessageDlg(#13+'Le service n''a pas rpondu ou n''a pas pu tre install.', mtError, [mbOK], 0);
        if OpenKey(ExtractFilePath(SERVICE_APPLICATION_KEY), false) then DeleteKey(NOMAPPLI);
     finally
        Free;
     end;
end;

procedure TFicheUpdateSoft.ActualiserComposantsService(ToutDesactiver: bool=false);
begin
     Service_Chemin.ReadOnly:=IsServiceInstalled(true) or ToutDesactiver or not IsAdmin;
     if Service_Chemin.ReadOnly then Service_Chemin.Color:=clSilver else Service_Chemin.Color:=$00E9DCA3;
     Service_Script.Color:=Service_Chemin.Color;
     Service_Nom.Color:=Service_Chemin.Color;
     Service_Password.Color:=Service_Chemin.Color;
     Service_Contexte_Compte_Nom.Color:=Service_Chemin.Color;
     Service_Contexte_Compte_Password.Color:=Service_Chemin.Color;
     Service_Chemin_Selection.Enabled:=not Service_Chemin.ReadOnly;
     Service_Script.ReadOnly:=Service_Chemin.ReadOnly;
     Service_Script_Selection.Enabled:=not Service_Chemin.ReadOnly;
     Service_Nom.ReadOnly:=Service_Chemin.ReadOnly;
     Service_Password.ReadOnly:=Service_Chemin.ReadOnly;
     Service_Chemin_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Script_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Nom_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Password_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Systeme.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Compte.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Compte_Nom_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Compte_Nom.ReadOnly:=Service_Chemin.ReadOnly;
     Service_Contexte_Compte_Password_Label.Enabled:=not Service_Chemin.ReadOnly;
     Service_Contexte_Compte_Password.ReadOnly:=Service_Chemin.ReadOnly;
     if ToutDesactiver then
     begin
          Service_Desinstaller.Enabled:=false;
          Service_Tester.Enabled:=false;
          Service_Installer.Enabled:=false;
          Service_Programmation_Label.Enabled:=false;
          Service_Programmation_Heure.Enabled:=false;
          Service_Programmation_Actif.Enabled:=false;
          Service_Programmation_Inactif.Enabled:=false;
     end
     else
     begin
          Service_Programmation_Label.Enabled:=Service_Chemin.ReadOnly and IsAdmin;
          Service_Programmation_Heure.Enabled:=Service_Programmation_Label.Enabled and Service_Programmation_Inactif.Checked;
          Service_Programmation_Actif.Enabled:=Service_Programmation_Label.Enabled;
          Service_Programmation_Inactif.Enabled:=Service_Programmation_Label.Enabled;
          if not Service_Programmation_Actif.Enabled then
          begin
               Service_Programmation_Actif.Tag:=1;
               Service_Programmation_Inactif.Checked:=true;
               Service_Programmation_Actif.Tag:=0;
          end;
          Service_Desinstaller.Enabled:=IsServiceInstalled(true);
          Service_Tester.Enabled:=not Service_Desinstaller.Enabled and IsAdmin and (Trim(Service_Chemin.Text)<>'') and (Trim(Service_Script.Text)<>'') and (Service_Contexte_Systeme.Checked or (not Service_Contexte_Systeme.Checked and (Trim(Service_Contexte_Compte_Nom.Text)<>'')));
          Service_Installer.Enabled:=not Service_Desinstaller.Enabled and IsAdmin and (Trim(Service_Chemin.Text)<>'') and (Trim(Service_Script.Text)<>'') and (Service_Contexte_Systeme.Checked or (not Service_Contexte_Systeme.Checked and (Trim(Service_Contexte_Compte_Nom.Text)<>'')));
     end;
end;

procedure TFicheUpdateSoft.Service_CheminChange(Sender: TObject);
begin
     if Service_Programmation_Actif.Tag=0 then
     begin
          if (Sender=Service_Chemin) and SameText(Service_Script.Text, Copy(IncludeTrailingPathDelimiter(ExtractFilePath(Service_Chemin.Text)), 1, length(Service_Script.Text))) then Service_Script.Text:=IncludeTrailingPathDelimiter(ExtractFilePath(Service_Chemin.Text));
          ActualiserComposantsService;
     end;
end;

procedure TFicheUpdateSoft.Service_Programmation_InactifClick(Sender: TObject);
begin
     if Service_Programmation_Actif.Tag=0 then
     begin
          if Service_Programmation_Actif.Checked then CreerTachePlanifiee(Service_Programmation_Heure.Time)
          else
          if Service_Programmation_Inactif.Checked then SupprimerTachePlanifiee;
          ActualiserComposantsService;
     end;
end;

procedure TFicheUpdateSoft.Service_Contexte_Compte_GroupeEnter(Sender: TObject);
begin if not Service_Contexte_Compte_Nom.ReadOnly then Service_Contexte_Compte.Checked:=true; end;

procedure TFicheUpdateSoft.Service_CheminExit(Sender: TObject);
begin
     if Service_Programmation_Actif.Tag=0 then
        if ExtractFileExt(Service_Chemin.Text)='' then Service_Chemin.Text:=IncludeTrailingPathDelimiter(Service_Chemin.Text);
end;

procedure TFicheUpdateSoft.Service_Contexte_SystemeClick(Sender: TObject);
begin
     if Sender=Service_Contexte_Systeme then begin Service_Contexte_Compte_Nom.Text:=''; Service_Contexte_Compte_Password.Text:=''; end;
     ActualiserComposantsService;
end;

procedure TFicheUpdateSoft.AjusterCheckBox(CheckBox: TCheckBox);
begin with CheckBox do if not WordWrap then Width:=GetSystemMetrics(SM_CXMENUCHECK)+6+Canvas.TextWidth(Caption); end;

procedure TFicheUpdateSoft.AjusterRadioButton(RadioButton: TRadioButton);
begin with RadioButton do if not WordWrap then Width:=GetSystemMetrics(SM_CXMENUCHECK)+6+Canvas.TextWidth(Caption); end;

procedure TFicheUpdateSoft.Index_Education_Dossier_Pronote32_SelectionClick(Sender: TObject);
begin
     if Dossier_Selection.Execute then Index_Education_Dossier_Pronote32.Text:=Dossier_Selection.DirName;
     Index_Education_Dossier_Pronote32Exit(Index_Education_Dossier_Pronote32);
end;

procedure TFicheUpdateSoft.Index_Education_Dossier_Pronote64_SelectionClick(Sender: TObject);
begin
     if Dossier_Selection.Execute then Index_Education_Dossier_Pronote64.Text:=Dossier_Selection.DirName;
     Index_Education_Dossier_Pronote32Exit(Index_Education_Dossier_Pronote64);
end;

procedure TFicheUpdateSoft.Index_Education_Dossier_EDT32_SelectionClick(Sender: TObject);
begin
     if Dossier_Selection.Execute then Index_Education_Dossier_EDT32.Text:=Dossier_Selection.DirName;
     Index_Education_Dossier_Pronote32Exit(Index_Education_Dossier_EDT32);
end;

procedure TFicheUpdateSoft.Index_Education_Dossier_EDT64_SelectionClick(Sender: TObject);
begin
     if Dossier_Selection.Execute then Index_Education_Dossier_EDT64.Text:=Dossier_Selection.DirName;
     Index_Education_Dossier_Pronote32Exit(Index_Education_Dossier_EDT64);
end;

procedure TFicheUpdateSoft.Index_Education_Dossier_Pronote32Exit(Sender: TObject);
begin
     if Sender is TEdit then if GetUNCName(TEdit(Sender).Text)<>'' then TEdit(Sender).Text:=IncludeTrailingPathDelimiter(GetUNCName(TEdit(Sender).Text));
end;

initialization

Configuration.Flash.Exclusions:=TStringList.Create;
Configuration.Flash.Exclusions.CaseSensitive:=false;
Configuration.Java.Exclusions:=TStringList.Create;
Configuration.Java.Exclusions.CaseSensitive:=false;
Configuration.Java.Sites:=TStringList.Create;
Configuration.Java.Sites.CaseSensitive:=false;
DefautConfiguration(Configuration);

finalization

Configuration.Flash.Exclusions.Free;
Configuration.Java.Exclusions.Free;
Configuration.Java.Sites.Free;
Finalize(Configuration.Firefox.Config);
Finalize(Configuration.Thunderbird.Config);

end.

