program vlc;

uses
  Windows,
  ShellAPI,
  SysUtils;

{$R *.res}
function StrPosW(Str, SubStr: PWideChar): PWideChar;
asm
         PUSH EDI 
         PUSH ESI 
         PUSH EBX 
         OR EAX, EAX 
         JZ @@2 
         OR EDX, EDX 
         JZ @@2 
         MOV EBX, EAX 
         MOV EDI, EDX 
         XOR AX, AX 
         MOV ECX, 0FFFFFFFFH 
         REPNE SCASW 
         NOT ECX 
         DEC ECX 
         JZ @@2 
         MOV ESI, ECX 
         MOV EDI, EBX 
         MOV ECX, 0FFFFFFFFH 
         REPNE SCASW 
         NOT ECX 
         SUB ECX, ESI 
         JBE @@2 
         MOV EDI, EBX 
         LEA EBX, [ESI - 1]
@@1:     MOV ESI, EDX 
         LODSW 
         REPNE SCASW 
         JNE @@2 
         MOV EAX, ECX 
         PUSH EDI 
         MOV ECX, EBX 
         REPE CMPSW 
         POP EDI 
         MOV ECX, EAX 
         JNE @@1 
         LEA EAX, [EDI - 2] 
         JMP @@3
@@2:     XOR EAX, EAX 
@@3:     POP EBX 
         POP ESI 
         POP EDI 
end;

function GetCommandLine: WideString;
type TPWideCharArray = array[0..0] of PWideChar;
var NumArgs: Integer;
    TempArgs: PPWideChar;
    i: Integer;
begin
     result:='';
     TempArgs := CommandLineToArgvW(GetCommandLineW, NumArgs);
     if TempArgs <> nil then
     begin
          for i := 1 to NumArgs - 1 do
          begin
               result:=result+' ';
               if StrPosW(TPWideCharArray(TempArgs^)[i], ' ')=nil then result:=result+TPWideCharArray(TempArgs^)[i] else result:=result+'"'+TPWideCharArray(TempArgs^)[i]+'"';
          end;
          LocalFree(THandle(TempArgs));
     end;
end;

const Parametres: WideString='--no-qt-privacy-ask --no-qt-updates-notif';
var Executable: Widestring;
begin
     Executable:=ExtractFilePath(ParamStr(0))+'vlc-original.exe';
     if FileExists(Executable) and SameText(ChangeFileExt(ExtractFileName(ParamStr(0)), ''), 'vlc') then
        ShellExecuteW(0, 'open', PWideChar(Executable), PWideChar(Parametres+GetCommandLine), nil, SW_SHOWNORMAL);
end.
